define("io.ox/office/editframework/app/editapplication",["io.ox/office/tk/utils","io.ox/office/tk/io","io.ox/office/tk/forms","io.ox/office/tk/dialogs","io.ox/office/tk/utils/driveutils","io.ox/office/baseframework/utils/errorcode","io.ox/office/baseframework/utils/errorcontext","io.ox/office/baseframework/utils/errorcontextdata","io.ox/office/baseframework/utils/clienterror","io.ox/office/baseframework/utils/infostate","io.ox/office/baseframework/utils/errormessages","io.ox/office/baseframework/utils/infomessages","io.ox/office/baseframework/app/baseapplication","io.ox/office/baseframework/app/extensionregistry","io.ox/office/editframework/utils/editconfig","io.ox/office/editframework/utils/operations","io.ox/office/editframework/app/rtconnection","io.ox/office/editframework/view/editlabels","io.ox/office/editframework/utils/operationutils","gettext!io.ox/office/editframework/main"],function(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){"use strict";function u(b){var c=_.isArray(b.actions)&&b.actions.every(_.isObject);return!c&&"actions"in b&&a.error("EditApplication.getActionsFromData(): invalid actions",b.actions),c?b.actions:void 0}function v(a){if(_.isObject(a)&&_.isString(a.action))switch(a.action){case"reload":a.action={itemKey:"document/reload",icon:r.RELOAD_ICON,label:r.RELOAD_LABEL};break;case"acquireedit":a.action={itemKey:"document/acquireedit",icon:r.EDIT_ICON,label:r.EDIT_LABEL};break;default:delete a.action}}var w=30,x=-1,y=m.extend({constructor:function(c,p,r,y,z){function A(a){var b={},c=_.intersection(_.keys(a),Wa);return _.each(c,function(c){b[c]=a[c]}),b}function B(){switch(Ja){case"offline":a.logSelenium("time="+_.now(),"key=app/loading","state=pending");break;case"preview":a.logSelenium("time="+_.now(),"key=app/preview","state=pending");break;case"initial":a.logSelenium("time="+_.now(),"key=app/preview","state=resolved"),a.logSelenium("time="+_.now(),"key=app/loading","state=resolved")}}function C(){var a=Ta?"error":_.isNumber(lb)?"preview":Ka?Ra||!oa.getEditMode()?"readonly":na.hasUnsavedChanges()?"sending":Ma?"ready":"initial":"offline";Ja!==a&&(Ja=a,na.setRootAttribute("data-app-state",Ja),na.trigger("docs:state",Ja),na.trigger("docs:state:"+Ja),B())}function D(a){Bb=_.isObject(a)&&_.isObject(a.action)&&_.isString(a.action.itemKey)&&"document/reload"===a.action.itemKey}function E(){var a={wantsToEditUser:Za,oldWantsToEditUser:$a,documentFileLockedByUser:Sa,fullFileName:na.getFullFileName(),oldEditUser:La};return a}function F(a,b){var c="info",d=t("Read-Only Mode"),e=null,f=null,g=null;_.isString(a)?(f={type:c,message:a,headline:d},isNaN(b)||(f.duration=b),f=_.extend({},f,{action:"acquireedit"})):(g=E(),e=na.getErrorState(),_.isObject(e)&&(e.isError()||e.isWarning())?f=k.getMessageData(e,g):(e=na.getInfoState(),_.isString(e)&&(f=l.getMessageData(e,g)))),na.extendMessageData(f),pa.yell(f)}function G(){Va=!0,!Ka||Ta||na.isInQuit()||(Ua=oa.getEditMode(),Ka=!1,qb?na.setInternalError(i.ERROR_OFFLINE_WHILE_SYNCHRONIZING,g.OFFLINE):(Ra=!0,oa.setEditMode(!1),C(),na.setInternalError(i.WARNING_READONLY_DUE_TO_OFFLINE,g.OFFLINE)),q.log("Connection offline handler called by Realtime!"))}function H(){!Va||Ka||Ta||na.isInQuit()||(q.log("Connection online handler called by Realtime!"),Ka=!0,pb&&(q.log("Client supports synchronization - starting to sync with server"),Ua?(na.setInternalError(i.WARNING_SYNC_AFTER_OFFLINE,g.SYNCHRONIZATION),q.log("Client is editor - synchronizing server with current client state"),qb="editSync",rb=null):(na.setInternalError(i.WARNING_SYNC_FOR_VIEWER,g.SYNCHRONIZATION),q.log("Client is viewer - waiting for server messages to unlock view"),qb="viewSync"),na.executeDelayed(function(){X(null,null,null,{cause:"timeout"})},1e3*w,"EditApplication: checkSynchronizationState"),na.repeatDelayed(function(){qb&&!va&&sa.sync()},{delay:0,repeatDelay:1e3*w/12,cycles:10},"EditApp: send sync requests")),C(),F())}function I(){q.log("Reset for connection called by Realtime!"),na.isLocked()||na.isInQuit()||na.setInternalError(i.ERROR_CONNECTION_RESET_RECEIVED,g.CONNECTION),qb&&X(null,null,null,{cause:"reset"})}function J(){var a=null;q.log("Connection time out called by Realtime!"),na.isLocked()||na.isInQuit()||(a=new f(i.ERROR_CONNECTION_TIMEOUT),a.setErrorContext(g.CONNECTION),na.restoreDocument(a))}function K(){q.log("NotMember for connection called by Realtime!"),na.isLocked()||na.isInQuit()||na.setInternalError(i.ERROR_CONNECTION_NOT_MEMBER,g.CONNECTION),qb&&X(null,null,null,{cause:"notMember"})}function L(){var a=null;q.log("Processing Stanza failed called by Realtime!"),na.isLocked()||na.isInQuit()||(a=new f(i.ERROR_UNKNOWN_REALTIME_FAILURE),a.setErrorContext(g.CONNECTION),na.restoreDocument(a))}function M(b,c){var d=null;na.isInQuit()||(d=new f(c),d.isError()||(d=new f(i.ERROR_CONNECTION_HANGUP)),a.warn('EditApplication.connectionHangupHandler: Error code "'+d.getCodeAsConstant()+'"'),d.setErrorContext(g.SYNCHRONIZATION),na.restoreDocument(d,c)),q.log("Server sent a hangup message due to inconsistency between client/server, client osn = "+oa.getOperationStateNumber())}function N(b,c){function d(){na.hasUnsavedChanges()?na.executeDelayed(d,2e3,"EditApplication: checkForPendingOperations 1"):Gb().then(function(){sa.canLoseEditRights(),La=Za||La,$a=Za,Za="",Ya=!1,na.getController().update(),q.log("sent canLoseEditRights")})}na.isInQuit()||(Ya=!0,na.getController().update(),Za=O(a.getStringOption(c,"wantsToEditUserId","")),$.when(Da.call(na)).always(function(){oa.setEditMode(!1),C(),q.log("handle PrepareLosingEditRights"),na.setCurrentInfoState(j.INFO_PREPARE_LOSING_EDIT_RIGHTS),na.executeDelayed(d,1e3,"EditApplication: checkForPendingOperations 2")}))}function O(a){var b=_.find(hb,function(b){return a===b.clientId})||{};return b.userName||""}function P(a){na.trigger("docs:editrights",a).trigger("docs:editrights:"+a)}function Q(){na.isInQuit()||na.setCurrentInfoState(j.INFO_EDITRIGHTS_ARE_TRANSFERED),q.log("handle AccepteAcquireEditRights"),P("accept")}function R(a,b){var c=null,d=null;if(!na.isInQuit()){switch(c=new f(b),c.getCodeAsConstant()){case"SWITCHEDITRIGHTS_NOT_POSSIBLE_SAVE_IN_PROGRESS_WARNING":d=j.INFO_EDITRIGHTS_SAVE_IN_PROGRESS;break;case"SWITCHEDITRIGHTS_IN_PROGRESS_WARNING":d=j.INFO_ALREADY_TRANSFERING_EDIT_RIGHTS;break;default:d=j.INFO_ALREADY_TRANSFERING_EDIT_RIGHTS}na.setCurrentInfoState(d)}q.log("handle DeclinedAcquireEditRights"),P("decline")}function S(a,b){var c=null,d=null;if(!na.isInQuit()&&(c=new f(b),c.isWarning())){switch(c.getCodeAsConstant()){case"SWITCHEDITRIGHTS_NEEDS_MORE_TIME_WARNING":d=j.INFO_EDITRIGHTS_PLEASE_WAIT;break;default:d=j.INFO_EDITRIGHTS_PLEASE_WAIT}na.setCurrentInfoState(d)}}function T(b,c){var d=null,e=null,g=null,h={};na.isInQuit()||(d=new f(c),d.isError()?xb&&xb.reject(c):(e=a.getStringOption(c,"fileId",null),g=a.getStringOption(c,"fileName",null),e&&g?(xb&&xb.resolve(c),h.id=e,h.filename=g,h.title=n.getBaseName(g),na.updateFileDescriptor(h),y.action="load",delete y.template,na.reloadDocument()):xb&&xb.reject(c)))}function U(){zb||(na.isInQuit()||na.setInternalError(i.WARNING_CONNECTION_INSTABLE,g.CONNECTION),q.log("handle NoUpdateFromServer"))}function V(a,b){var c=new f(b);!na.isInQuit()&&c.isError()&&na.setInternalError(c,g.FLUSH),q.log("handle flushErrorInfo from server")}function W(b){var c=a.getStringOption(b,"editUserId",""),d=O(c),h=oa.getEditMode(),k=h,l=na.getFileDescriptor(),m=oa.getOperationStateNumber(),n=a.getIntegerOption(b,"serverOSN",-1),o=new f(b),p=a.getIntegerOption(b,"lockedByUserId",x),r=a.getBooleanOption(b,"writeProtected",null),s=a.getObjectOption(b,"sync",null);if(!Ta&&0!==_.intersection(_.keys(b),Wa).length){if(c!==Xa&&(q.log("Edit rights changed, new editing user id: "+c),k=qa===c,na.setCurrentInfoState(j.INFO_USER_IS_CURRENTLY_EDIT_DOC,{showMessage:!1})),a.getBooleanOption(b,"failSafeSaveDone",!1)&&e.propagateChangeFile(l),a.getBooleanOption(b,"hasErrors",!1))return na.setInternalError(i.ERROR_GENERAL_SYNCHRONIZATION_ERROR,g.SYNCHRONIZATION),void q.error("synchronization to the server has been lost.");Ra||(_.isBoolean(r)&&r?(Ra=!0,oa.setEditMode(!1),na.setInternalError(i.WARNING_NO_PERMISSION_FOR_DOC,g.READONLY)):p!==x&&ox.user_id!==p&&(Sa=a.getStringOption(b,"lockedByUser",""),Ra=!0,oa.setEditMode(!1),na.setInternalError(i.WARNING_DOC_IS_LOCKED,g.READONLY))),Ra||(q.log("Edit mode: "+k),oa.setEditMode(k),Ka&&c&&c!==Xa&&(Xa=c,La=d),k&&h===!1&&na.setCurrentInfoState(j.INFO_EDITRIGHTS_RECEIVED),Ka&&!k&&h&&-1!==n&&m>n&&(na.setInternalError(i.ERROR_GENERAL_SYNCHRONIZATION_ERROR,g.SYNCHRONIZATION),q.error("synchronization between client and server is broken. Switching editor into read-only mode. New edit mode: "+k+"Old edit mode: "+h+", Server OSN: "+n+", Client OSN: "+m)),!k&&(!Ka||h||d!==La&&d.length)&&(La=d,na.setCurrentInfoState(j.INFO_USER_IS_CURRENTLY_EDIT_DOC)),(o.isError()||o.isWarning())&&na.setInternalError(o,g.GENERAL)),X(c,m,n,null,s),Ka=!0,C()}}function X(a,b,c,d,e){var h=null,k=null;if(qb){if(q.log("Checking synchronization state with server"),d){switch(d.cause){case"timeout":q.log("Synchronization not possible - maybe connection instance is gone"),h=new f(i.ERROR_SYNCHRONIZATION_TIMEOUT),h.setErrorContext(g.SYNCHRONIZATION),qb=null;break;case"notMember":case"reset":case"error:disposed":q.log("Synchronization not possible - connection instance is gone or rt-state broken"),na.setCurrentInfoState(),h=new f(i.ERROR_SYNCHRONIZATION_NOT_POSSIBLE),h.setErrorContext(g.SYNCHRONIZATION),qb=null}na.restoreDocument(h)}switch(qb){case"editSync":if(_.isObject(e)&&(rb=e),a===Xa&&b!==c)return void q.log("Synchronization in progess server osn != client osn");if(a===Xa)if(b===c){if(!_.isObject(rb))return;k=new f(rb),k.isError()?(q.log("Synchronization detected bad document consistency state"),k.setErrorContext(g.SYNCHRONIZATION),na.restoreDocument(k)):(q.log("Synchronization successfully completed"),Ra=!1,oa.setEditMode(!0),na.setCurrentInfoState(j.INFO_SYNCHRONIZATION_SUCCESSFUL))}else q.log("Synchronization not possible - document has been changed"),h=new f(i.ERROR_SYNCHRONIZATION_DOC_CHANGED),h.setErrorContext(g.SYNCHRONIZATION),na.restoreDocument(h);else q.log("Synchronization not possible - editor changed"),na.setCurrentInfoState(),h=new f(i.ERROR_SYNCHRONIZATION_LOST_EDIT_RIGHTS),h.setErrorContext(g.SYNCHRONIZATION),na.restoreDocument(h);break;case"viewSync":q.log("Synchronization for viewer completed"),Ra=!1}qb=null}}function Y(b){var c=na.getFileDescriptor(),d=a.getStringOption(b,"fileName",""),e=a.getStringOption(b,"fileVersion",""),f={};d.length>0&&d!==a.getStringOption(c,"filename")&&(f.filename=d),e.length>0&&e!==a.getStringOption(c,"version")&&(f.version=e),Ta||_.isEmpty(f)||(na.updateFileDescriptor(f),na.getController().update(),C())}function Z(b){if(Ta)return q.error("EditApplication.applyRemoteActions(): failed due to internal error"),$.Deferred().reject();if(!_.isObject(b))return a.error("EditApplication.applyRemoteActions(): invalid data, expecting object:",b),$.Deferred().reject();var c=u(b);if(!_.isArray(c)||0===c.length)return $.when();q.log("EditApplication.applyRemoteActions(): last remote action: "+JSON.stringify(_.last(c)));var d=oa.applyActions(c,{external:!0});return d.done(function(){Na=!0}),d.fail(function(){q.error("EditApplication.applyRemoteActions(): failed")}),d}function aa(a){var b=!1,c=oa.getOperationStateNumber(),d=-1;return Ab&&_.isArray(a)&&a.length>0&&("editSync"===qb&&sa.hasPendingActions()?b=!0:_.isObject(a[0]&&_.isArray(a[0].operations))&&(d=a[0].operations[0].osn,b=c!==d)),b}function ba(){function c(a){return na.setInternalError(a,g.CREATEDOC),$.Deferred().reject({cause:h?"convert":"create"})}var d={},h=!1;switch(a.getStringOption(y,"action","load")){case"load":return e.getFile(y.file).then(function(a){y.file=a,na.updateFileDescriptor(a)});case"new":_.extend(d,a.getObjectOption(z,"newDocumentParams"));break;case"convert":h=!0;break;default:return a.error("EditApplication.initFileHandler(): unsupported launch action"),$.Deferred().reject()}var i=a.getObjectOption(y,"templateFile"),k=a.getBooleanOption(y,"preserveFileName",!1),l=a.getStringOption(y,"target_filename",t("unnamed")),m=a.getStringOption(y,"target_folder_id",""),n=a.getObjectOption(i,"origin"),o=null;Db("createNewDocStart"),_.extend(d,{action:"createdefaultdocument",document_type:na.getDocumentType(),target_filename:l,target_folder_id:m,preserve_filename:k,convert:h}),y.template&&_.extend(d,{action:"createfromtemplate",file_id:i.id}),_.isObject(i)&&_.extend(d,{file_id:i.id,version:i.version}),na.waitForImportSuccess(function(){var b=y.template?!1:m!==a.getStringOption(na.getFileDescriptor(),"folder_id");h=y.template?na.getFileDescriptor().converted:h,h?na.setCurrentInfoState(b?j.INFO_DOC_CONVERT_STORED_IN_DEFFOLDER:j.INFO_DOC_CONVERTED_AND_STORED):b&&na.setCurrentInfoState(j.INFO_DOC_CREATED_IN_DEFAULTFOLDER)});var p=_.url.hash("fields"),q=_.url.hash("fields-source");return(p||q)&&(_.url.hash("fields",null),_.url.hash("fields-source",null),d.fields=p,d.sourcefields=q),o=na.sendRequest(b.FILTER_MODULE_NAME,d),o=o.then(function(a){Db("createNewDocAfterRequest");var b=new f(a);return b.isError()?c(b):a},function(){return c()}),o=o.then(function(a){return e.getFile(a.file).then(function(b){return a.file=b,a})}),o=o.then(function(b){function c(a){var b="resolved"===this.state();return na.leaveBusyDuringImport(!b).then(function(){return Db("afterLeaveBusyEarly"),b?a:$.Deferred().reject(a)},function(){return b?arguments[0]:a})}return _.isObject(b.file)?(n&&(b.file.origin=n),b.file.source="drive",nb=_.isString(b.htmlDoc)&&_.isArray(b.operations)&&b.operations.length>0,nb&&za?za.call(na,b.htmlDoc,{operations:b.operations}).then(c,c).then(function(){return b}):b):(a.error("EditApplication.initFileHandler(): missing file descriptor"),$.Deferred().reject())}),o.then(function(a){return a.file})}function ca(){function b(b,c,d){a.info("EditApplication.importHandler(): "+c+" in "+b+"ms"+(_.isString(d)?" ("+d+")":""))}function c(){pa.enterBusy({cancelHandler:_.bind(na.quit,na),immediate:!0,showFileName:!0,warningLabel:t("Sorry, your document is very large. It will take some time to be loaded."),warningDelay:1e4})}function d(c,d,e,f){var g=_.now(),h=null;return Db(e+"Start",g),h=_.isFunction(c)?c.call(na):$.when(),h=h.then(function(c){var h=_.now(),i=h-g,j=f>0?a.round(i/f,.001):0;return b(i,d,f>0?f+" elements, "+j+"ms per element":null),Db(e+"End",h),na.isInQuit()?$.Deferred().reject({cause:"closing"}):c})}function e(a){if(_.isObject(a))switch(a.type){case"reset":na.setInternalError(i.ERROR_CONNECTION_RESET_RECEIVED,g.LOAD),s.reject(i.ERROR_CONNECTION_RESET_RECEIVED);break;case"offline":na.setInternalError(i.ERROR_OFFLINE_WHILE_LOADING,g.LOAD),s.reject(i.ERROR_OFFLINE_WHILE_LOADING);break;case"timeout":na.setInternalError(i.ERROR_CONNECTION_TIMEOUT,g.LOAD),s.reject(i.ERROR_CONNECTION_TIMEOUT);break;case"error:join":na.setInternalError(i.ERROR_CONNECTION_JOIN_FAILED,g.LOAD),s.reject(i.ERROR_CONNECTION_JOIN_FAILED);break;case"error:disposed":na.setInternalError(i.ERROR_CONNECTIONINSTANCE_DISPOSED,g.LOAD),s.reject(i.ERROR_CONNECTIONINSTANCE_DISPOSED);break;case"error:stanzaProcessingFailed":na.setInternalError(i.ERROR_UNKNOWN_REALTIME_FAILURE,g.LOAD),s.reject(i.ERROR_UNKNOWN_REALTIME_FAILURE);break;default:na.setInternalError(i.ERROR_UNKNOWN_REALTIME_FAILURE,g.LOAD),s.reject(i.ERROR_UNKNOWN_REALTIME_FAILURE)}}function h(a,b){b&&b.finalLoadUpdate?b.hasErrors?p.reject(b):(p.resolve(b),q.log("Final load update received for asynchronous load")):(n.push(b),q.log("Update received during document import"))}function j(b){function c(b,c){return sa.on({hangup:M,preparelosingeditrights:N,declinedacquireeditrights:R,acceptedacquireeditrights:Q,noUpdateFromServer:U,flusherrorinfo:V,infomessage:S,renameandreload:T}),W(b),Db("editMode"),yb=a.getStringOption(b.syncInfo,"restore_id",null),na.waitForImportSuccess(function(){q.log("Applying document update messages, count = "+c.length),_.each(c,function(a){Fb(a)}),q.log("Applying update messages collected during connect/import, count = "+n.length),_.each(n,function(a){Fb(a)}),sa.off("update",h).on("update",function(a,b){na.applyUpdateMessageData(b)}),sa.off("reset",e).on("reset",I),sa.off("offline",e).on("offline",G),sa.off("timeout",e).on("timeout",J),sa.off("error:stanzaProcessingFailed",e).on("handleCriticalMsgWhileLoading",L)}),$.when()}function g(){function c(){_.each(D,function(a){localStorage.removeItem(w+a.extension)}),localStorage.removeItem(B),localStorage.removeItem(x),localStorage.removeItem(C)}window.Storage&&_a&&cb&&db&&b.syncInfo&&b.syncInfo.fileVersion&&b.syncInfo["document-osn"]&&_.isFinite(b.syncInfo["document-osn"])&&b.syncInfo.fileId&&b.syncInfo.folderId&&_.isFunction(oa.setFullModelNode)&&_.isFunction(oa.getSupportedStorageExtensions)&&(w=b.syncInfo.fileId+"_"+b.syncInfo.folderId,C=w+"_FILEVERSION",x=w+"_STORAGEVERSION",B=w+"_OSN",D=oa.getSupportedStorageExtensions(),y=localStorage.getItem(x)&&parseInt(localStorage.getItem(x),10)||1,y>=ab?(a.info("EditApplication.importHandler(): document-osn="+b.syncInfo["document-osn"]+", document-rev="+b.syncInfo.fileVersion),localStorage.getItem(C)&&localStorage.getItem(C)===b.syncInfo.fileVersion&&localStorage.getItem(B)&&parseInt(localStorage.getItem(B),10)===parseInt(b.syncInfo["document-osn"],10)?a.iterateArray(D,function(d){var e=w+d.extension,f={usedLocalStorage:!0};if(_.isObject(d.additionalOptions)&&_.extend(f,d.additionalOptions),localStorage.getItem(e))a.info("EditApplication.importHandler(): loading document from local storage. Key: "+e+" Length: "+localStorage.getItem(e).length),eb=!0,m=!0,0===E&&oa.setLoadDocumentOsn(parseInt(b.syncInfo["document-osn"],10)),oa.setFullModelNode(localStorage.getItem(e),f),E++;else if(a.info("EditApplication.importHandler(): optional local storage value not found. Key: "+e),!d.optional)return a.info("EditApplication.importHandler(): file in local storage not found. Key: "+w+". But found OSN key: "+B),c(),a.BREAK}):(a.info("EditApplication.importHandler(): file in local storage not found. Key: "+w),c())):(a.info("EditApplication.importHandler(): version of file in local storage not supported. Key: "+w),c()))}function i(){var c=null,d="";!b.htmlDoc&&o.DEBUG&&!nb&&oa.setFullModelNode&&na.getController().getItemValue("debug/useFastLoad")&&na.getFileDescriptor()&&!a.stringEndsWith(na.getFileDescriptor().filename,"_ox")&&pa.yell({type:"error",headline:_.noI18n("Error in fastload"),message:_.noI18n('you should have a look in the backend logfiles ("Exception while creating the generic html document")')}),!eb&&b.htmlDoc&&_.isFunction(oa.setFullModelNode)&&!nb&&(a.info("EditApplication.importHandler(): load complete HTML document, osn: ",b.syncInfo["document-osn"]),oa.setLoadDocumentOsn(parseInt(b.syncInfo["document-osn"],10)),c=JSON.parse(b.htmlDoc),c.mainDocument&&oa.setFullModelNode(c.mainDocument),c.headerFooter&&(_.each(c.headerFooter,function(a){d+=a}),oa.setFullModelNode(d,{headerFooterLayer:!0}),oa.getPageLayout().headerFooterCollectionUpdate()),c.comments&&(d="",_.each(c.comments,function(a){d+=a}),oa.setFullModelNode(d,{commentLayer:!0})),oa.trigger("fastload:done"))}function j(){var c=null;return a.getBooleanOption(b,"hasErrors",!1)?(a.error("EditApplication.importHandler(): server side error"),c={cause:"server"}):a.getBooleanOption(b,"operationError",!1)?(a.error("EditApplication.importHandler(): operation failure"),c={cause:b.message}):s.isError()?(a.error("EditApplication.importHandler(): server side error, error code = "+s.getCodeAsConstant()),c={cause:"server"}):0===qa.length?(a.error("EditApplication.importHandler(): missing client identifier"),c={cause:"noclientid"}):_.isArray(l)&&0!==l.length||(a.error("EditApplication.importHandler(): missing actions"),c={cause:"noactions"}),c}function k(){return a.getUserInfo(ox.user_id).done(function(a){ra=a.operationName})}var l=u(b),p=[],r=A(b),s=new f(b),v=null,w=null,x=null,y=0,B=null,C=null,D=null,E=0,F=null;return qa=a.getStringOption(b,"clientId",""),fb[qa]=0,v=j(),_.isObject(v)?(v=_.extend(v,da(b)),$.Deferred().reject(v)):(Cb(),g(),i(),p.push(r),nb?(oa.setOperationStateNumber(parseInt(b.serverOSN,10)),c(b,p).then(k)):(F=d(wa,"preprocessing finished","preProcessing"),F=F.then(k).then(function(){function e(){var b=a.getBooleanOption(z,"applyActionsDetached",!1);return b&&pa.detachAppPane(),oa.applyActions(l,f).always(function(){b&&pa&&!pa.destroyed&&pa.attachAppPane()})}var f={external:!0,useStorageData:m},g=o.DEBUG?a.getSum(l,function(b){return a.getArrayOption(b,"operations",[]).length}):0,i=null;return m&&Ha&&(f.filter=Ha),i=d(e,"operations applied","applyActions",g),i=i.then(function(){var a=null;return oa.getOperationStateNumber()<0?$.Deferred().reject({cause:"applyactions",headline:t("Synchronization Error")}):(a=d(m?ya:xa,"postprocessing finished","postProcessing"),a=a.then(function(){return c(b,p)},function(a){return _.extend({cause:"postprocess"},a)}))},function(a){return sa&&sa.off("update",h),_.extend({cause:"applyactions"},a)})},function(a){return _.extend({cause:"preprocess"},a)})))}function k(b){function c(){function a(){return p.then(function(a){return j(a)},function(a){return da(_.extend({cause:"asyncload"},a))})}var c=null;return c=h||g.isError()?j(b):d(a,"asynchronous import","asyncLoad")}function e(){var a=d(wa,"preview preprocessing finished","previewPreProcessing");return a=a.then(function(){wa=null;var a=oa.applyActions({operations:b.preview.operations},{external:!0});return a=a.then(function(){return Aa.call(na,i)?na.leaveBusyDuringImport():$.when()},function(){return b.operationError=!0,b.message=t("An unrecoverable error occurred while modifying the document."),h=!0,$.when()})})}var g=new f(b),h=a.getBooleanOption(b,"syncLoad",!1),i=a.getObjectOption(b,"preview"),k=$.when();return i&&_.isArray(i.operations)&&(k=e()),k=k.then(c)}var l=0,m=!1,n=[],p=$.Deferred(),r=null,s=$.Deferred();return Db("importDocStart"),oa.getUndoManager().on("undogroup:open",function(){ua=ea()}),oa.getUndoManager().on("undogroup:close",function(){ua.operations.length>0&&la(ua),ua=null}),oa.on("operations:success",function(a,b,c){c||vb||(_.isObject(ua)?(q.log("operations:success - push operations into pending action"),ua.operations=ua.operations.concat(b)):la(ea(b)))}),oa.on("cacheBuffer:flush",function(){q.log("cacheBuffer:flush received - send cached operations"),_.isFunction(Ga)&&wb.length&&(ta=Ga.call(na,ta,wb),Gb())}),oa.on("operations:error",function(){na.isImportFinished()?(na.setInternalError(i.ERROR_WHILE_MODIFYING_DOCUMENT,g.GENERAL),q.error("An unrecoverable error occurred while modifying the document")):(na.setInternalError(i.ERROR_WHILE_LOADING_DOCUMENT,g.GENERAL),q.error("An unrecoverable error occurred while loading the document"))}),na.getWindowNode().on("drop",!1),sa=new q(na,z),sa.on({online:H,offline:e,timeout:e,"error:notMember":K,reset:e,"error:stanzaProcessingFailed":e,"error:joinFailed":e,"error:disposed":e,update:h}),nb||c(),b(l,"initialization finished"),r=d(function(){var b={fastEmpty:nb,useLocalStorage:cb,app:na.getDocumentType(),newDocument:"new"===a.getStringOption(y,"action")};return sa.connect(b).then(function(a){s.resolve(a)},function(a){s.reject(a)}),s.promise()},"actions downloaded","connect"),r=r.then(k).then(null,da),r.always(function(){lb=null,C(),Db("leaveBusy")}),r}function da(a){if(na.isInQuit()&&(a={cause:"quit"}),ob)return{cause:""};var b=new f(a),c=b.getCodeAsConstant(),d=null,e=null;switch(Ta=!0,Ba.call(na,a),a=_.clone(a),c){case"GENERAL_FILE_NOT_FOUND_ERROR":Qa=!0;break;case"NO_ERROR":if(d=f.extractRealtimeError(a),d&&d.code&&"RT_STANZA"===d.prefix)switch(q.log("ImportFailedHandler: RT error detected: RT_STANZA-"+d.code),d.code){case 6:case 1009:case 1014:b=new f(i.ERROR_LOAD_DOC_FAILED_SERVER_TOO_BUSY);break;case 1010:b=new f(i.ERROR_CONNECTIONINSTANCE_DISPOSED);break;case 1016:b=new f(i.ERROR_SERVER_DENIES_CONNECTION);break;default:b=new f(i.ERROR_UNKNOWN_REALTIME_FAILURE)}}if(d=a.cause||a.error,!b.isError()&&_.isString(d)){switch(d){case"bad server component":b=new f(i.ERROR_BAD_SERVER_COMPONENT_DETECTED);break;case"timeout":b=new f(i.ERROR_LOAD_DOC_FAILED_SERVER_TOO_BUSY);break;case"0 simulated fail":b=new f(i.ERROR_CONNECTION_RESET_RECEIVED)}if(!b.isError())switch(e=_.isString(a.code)?a.code:""){case"0000":b=new f(i.ERROR_CONNECTION_TIMEOUT)}}return b.isError()||(b=new f(i.ERROR_UNKNOWN_REALTIME_FAILURE)),na.isInQuit()||na.setInternalError(b,g.LOAD,null,{showMessage:!1}),ob=!0,a}function ea(a){return{operations:a||[]}}function fa(a){return Ta?$.Deferred().reject():$.when(Ca.call(na,a)).then(Gb).then(_.bind(sa.flushDocument,sa))}function ga(){var a=$.Deferred();return na.isOffline()||Ta?a.resolve():$.when(Ca.call(na,"quit")).then(function(){var b=5e3,c=null,d=Gb();return"pending"===d.state()&&(c=na.executeDelayed(function(){"pending"===d.state()&&a.resolve({cause:"timeout"})},b,"EditApplication: beforeQuitHandler"),d.always(function(){c.abort()})),d}).done(function(){var b=null;na.hasUnsavedChanges()&&qa===Xa?(b=new d.ModalQueryDialog(t("This document contains unsaved changes. Do you really want to close?")),b.show().done(a.resolve.bind(a)).fail(a.reject.bind(a))):a.resolve()}).fail(function(){a.resolve()}),a.promise()}function ha(b){function c(b){var c=$.Deferred(),d=new f(b),i={},j=null,k=null,l=null,n=null;return d.isError()||d.isWarning()?(j=a.getStringOption(b,h.RESTORED_FILEID,null),k=a.getStringOption(b,h.RESTORED_FILENAME,null),l=a.getStringOption(b,h.RESTORED_FOLDERID,null),n=a.getStringOption(b,h.RESTORED_ERRORCODE,"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"),_.isString(j)&&_.isString(k)&&_.isString(l)?(n=new f(n===f.CONSTANT_NO_ERROR?{errorClass:f.ERRORCLASS_ERROR,error:"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"}:{errorClass:f.ERRORCLASS_ERROR,error:n}),i[h.RESTORED_FILENAME]=k,e.getPath(l).always(function(a){i[h.RESTORED_PATHNAME]=e.preparePath(a),i[h.ORIGINAL_FILEID]=na.getFileDescriptor().id,na.updateFileDescriptor({id:j,folder_id:l}),na.setInternalError(n,g.CLOSE,d,{additionalData:i})})):na.setInternalError(d,g.CLOSE,null,{additionalData:i}),oa&&pa?(na.registerQuitHandler(function(){c.reject()}),na.quit=function(a){return function(){return c.reject(),a.call(na)}}(na.quit),m.idle(),c.always(function(){m.busy()})):c.reject(),d.getDescription()&&a.log(d.getDescription()),c.promise()):b}function d(a){return c(a)}function i(a){p&&pa.updateBusyProgress(a)}function j(b){function c(c){var d=a.getBooleanOption(c,"migration",!1);_.each(n,function(a){localStorage.removeItem(e+a)}),d&&(_.isFinite(b.syncInfo.fileVersion)?_.each(_.range(b.syncInfo.fileVersion>m?b.syncInfo.fileVersion-m:0,b.syncInfo.fileVersion),function(a){_.each(n,function(b){localStorage.removeItem(e+"_"+a+b)})}):(localStorage.removeItem(e+"_"+b.syncInfo.fileVersion),localStorage.removeItem(e+"_CURRENTVERSION")))}var d=null,e=null,f=null,g=null,h=null,i=null,j=Ma||Pa||Na,k=oa.getOperationStateNumber(),l=0,m=20,n=["_OSN","_FILEVERSION","_STORAGEVERSION"];return Cb(),(j||!eb)&&b&&b.syncInfo&&window.Storage&&_a&&cb&&db&&_.isFunction(oa.getFullModelDescription)&&b.syncInfo.fileVersion&&b.syncInfo.fileId&&b.syncInfo.folderId&&b.syncInfo["document-osn"]&&_.isFinite(b.syncInfo["document-osn"],10)&&k===parseInt(b.syncInfo["document-osn"],10)&&(i=$.Deferred(),na.executeDelayed(function(){p=!0},1500,"EditApplication: showing progress bar"),na.executeDelayed(function(){i.notify(.1),d=_.now(),oa.getFullModelDescription(i,.1,.9).always(function(){e=b.syncInfo.fileId+"_"+b.syncInfo.folderId,_.isFunction(oa.getSupportedStorageExtensions)&&_.each(oa.getSupportedStorageExtensions(),function(a){a&&_.isString(a.extension)&&n.push(a.extension)}),c({migration:!0})}).done(function(i){a.iterateArray(i,function(i){var j=i.htmlString,k=e+i.extension;a.info("quitHandler, created document string with size: "+j.length+". Time for conversion: "+(_.now()-d)+" ms.");try{if(0===l&&(f=e+"_OSN",g=e+"_FILEVERSION",h=e+"_STORAGEVERSION",localStorage.setItem(f,b.syncInfo["document-osn"]),localStorage.setItem(h,bb),localStorage.setItem(g,b.syncInfo.fileVersion)),localStorage.setItem(k,j),!localStorage.getItem(k)||localStorage.getItem(k).length!==j.length)return c(),a.info("quitHandler, failed to save document in local storage (1)."),a.BREAK;if(a.info("quitHandler, successfully saved document in local storage with key: "+k),0===l){if(!localStorage.getItem(f)||parseInt(localStorage.getItem(f),10)!==b.syncInfo["document-osn"])return c(),a.info("quitHandler, failed to save OSN for document in local storage (1)."),a.BREAK;a.info("quitHandler, successfully saved OSN for document in local storage with key: "+f+" : "+b.syncInfo["document-osn"])}l++}catch(m){return c(),a.info("quitHandler: failed to save document and/or document OSN in local storage."),a.BREAK}})}).always(function(){i.notify(1),i.resolve(b)})},void 0,"EditApplication: getFullModelDescription")),null===i?b:i.promise()}function k(){return e.propagateChangeFile(n)}var l=null,m=na.getWindow(),n=na.getFileDescriptor(),p=!1,q=null;m&&m.busy();var r=Ma||Pa||Na||Qa;return(n&&(r||o.LOG_PERFORMANCE_DATA)||"new"!==a.getStringOption(y,"action")&&!y.template&&hb.length<=1)&&(q={file:_.extend({last_opened:Date.now()},n),app:na.getDocumentType()},o.LOG_PERFORMANCE_DATA&&(ka(),q.performanceData=kb)),l=n&&sa&&!na.isOffline()&&!Ta?sa.closeDocument(q).then(c,d).then(j).progress(i):$.when(),sa&&l.always(function(){sa.destroy(),sa=null}),n&&(r?l=l.then(k,k):"reload"!==b&&("new"===a.getStringOption(y,"action")||y.template)&&hb.length<=1&&!y.keepFile&&(l=l.then(function(){return e.purgeFile(n)}))),l}function ia(a){if(q.log("pendingUpdates: updates queued, pending = "+(jb.length+1)),jb.length>1&&qa!==a.editUserId){q.log("pendingUpdates: pending updates must be changed to user: "+a.editUserId+" now.");var b={editUser:a.editUser,editUserId:a.editUserId};_.each(jb,function(a){_.extend(a,b)})}jb.push(a)}function ja(a,b){kb[a]=b}function ka(){_.each(na.getTimerLogCollector(),function(a,b){Db(b,a)}),Db("launchStart",na.getLaunchStartTime()),Db("triggerImportSuccess",mb),ja("LocalStorage",eb),ja("FastEmptyLoad",nb),ja("user-agent",navigator.userAgent),ja("platform",navigator.platform),ja("user",ox.user),ja("version",ox.version),ja("server",ox.abs)}function la(a){ub?Hb(a):(q.log("evaluateAction: distribute = false, operations must be cached"),wb.push(a))}function ma(a){var b=_.indexOf(tb,a);return 0>b&&(b=tb.length,tb.push(a)),b}var na=this,oa=null,pa=null,qa=null,ra=null,sa=null,ta=[],ua=null,va=!1,wa=a.getFunctionOption(z,"preProcessHandler"),xa=a.getFunctionOption(z,"postProcessHandler"),ya=a.getFunctionOption(z,"postProcessHandlerStorage"),za=a.getFunctionOption(z,"fastEmptyLoadHandler"),Aa=a.getFunctionOption(z,"previewHandler"),Ba=a.getFunctionOption(z,"importFailedHandler",$.noop),Ca=a.getFunctionOption(z,"prepareFlushHandler",$.noop),Da=a.getFunctionOption(z,"prepareLoseEditRightsHandler",$.noop),Ea=a.getFunctionOption(z,"prepareRenameHandler",$.noop),Fa=a.getFunctionOption(z,"optimizeOperationsHandler"),Ga=a.getFunctionOption(z,"mergeCachedOperationsHandler"),Ha=a.getFunctionOption(z,"operationFilter"),Ia=a.getNumberOption(z,"sendActionsDelay",0),Ja=null,Ka=!1,La=null,Ma=!1,Na=!1,Oa=null,Pa=!1,Qa=!1,Ra=!1,Sa=null,Ta=!1,Ua=!1,Va=!1,Wa=["editUserId","editUser","hasErrors","writeProtected","activeUsers","locked","lockedByUser","lockedByUserId","failSafeSaveDone","wantsToEditUser","wantsToEditUserId"],Xa=null,Ya=!1,Za=null,$a=null,_a=a.getBooleanOption(z,"localStorageApp",!1),ab=a.getIntegerOption(z,"requiredStorageVersion",0),bb=a.getIntegerOption(z,"supportedStorageVersion",0),cb=o.USE_LOCAL_STORAGE&&ox.secretCookie===!0,db=a.isLocalStorageSupported(),eb=!1,fb={},gb=1,hb=[],ib=[],jb=[],kb={},lb=null,mb=0,nb=!1,ob=!1,pb=a.getBooleanOption(z,"supportsOnlineSync",!1),qb=null,rb=null,sb={},tb=[],ub=!0,vb=!1,wb=[],xb=null,yb=null,zb=!1,Ab=o.ENABLED_RESTORE_DOCUMENT,Bb=!0;m.call(this,c,p,r,ca,y,_.extend({},z,{initFileHandler:ba,flushHandler:fa,messageDataHandler:v}));var Cb=o.DEBUG?function(){cb=na.getUserSettingsValue("debugUseLocalStorage",cb);

}:$.noop,Db=o.LOG_PERFORMANCE_DATA?function(a,b){var c=b||_.now(),d=a+"Absolute",e=a+"Duration";ja(d,c),ja(e,c-na.getLaunchStartTime())}:$.noop,Eb=this.createSynchronizedMethod(function(b){var c=ib,d=[];return _.isArray(b.activeUsers)?(_.each(b.activeUsers,function(b){var c=_.isObject(b)&&_.isString(b.userId)&&_.isNumber(b.id);c?d.push(a.getUserInfo(b.id).then(function(a){return b.userDisplayName=a.displayName,b.userOperationName=a.operationName,b})):a.warn("EditApplication.applyUserData(): missing identifier")}),$.when.apply($,d).done(function(){hb=_.map(arguments,function(a){var b={};return b.clientId=a.userId,b.userId=a.id,b.userName=a.userDisplayName,b.userOperationName=a.userOperationName,b.guest=a.guest,b.active=a.active===!0||_.isNumber(a.durationOfInactivity)&&a.durationOfInactivity<60,b.remote=qa!==b.clientId,b.editor=Xa===b.clientId,_.isObject(a.userData)&&(b.userData=a.userData),b.clientId in fb||(fb[b.clientId]=gb,gb+=1),b.clientIndex=fb[b.clientId],b.colorIndex=na.getAuthorColorIndex(b.userOperationName),b}),ib=_.where(hb,{active:!0}),ib=_.sortBy(ib,"clientIndex"),_.isEqual(c,ib)||(a.info("EditApplication.applyUserData(): activeClients=",ib),na.trigger("docs:users",ib))})):$.when()}),Fb=this.createSynchronizedMethod(function(b,c){q.log("EditApplication.applyUpdateMessageData(): received update message:",b);var d=null,e=a.getArrayOption(b,"senderOperations"),g=u(b);return aa(g)?void na.restoreDocument(new f(i.ERROR_SYNCHRONIZATION_LOST_EDIT_RIGHTS)):(d=Z(b),e&&e.length>0&&(d=d.then(function(){return oa.applyActions({operations:e},{external:!0,shallow:!0})})),d.done(function(){W(b),Y(b),Eb(b),jb.shift(),q.log("EditApplication.applyUpdateMessageData(): update processed, pending = "+jb.length),a.getBooleanOption(c,"notify",!1)&&na.trigger("docs:update",b)}),d)},"EditApplication: applyUpdateMessageData"),Gb=function(){function b(){if(q.debug&&Ya&&ta&&ta.length>0){var d=ta[ta.length-1].operations;try{d&&d.length>0&&a.log("EditApplication.sendActionsBuffer(): last action: "+JSON.stringify(JSON.stringify(d[d.length-1])))}catch(e){}}Fa&&(ta=Fa.call(na,ta)),sa.sendActions(ta).done(function(){Ta?(q.error("EditApplications.sendActionsBuffer(): sent successful, but internal error detected!"),c.reject()):0===ta.length?c.resolve():b()}).fail(function(a){q.error("EditApplications.sendActionsBuffer(): rtConnection.sendActions promise failed!"),c.reject(a)}),ta=[]}var c=null;return function(){return q.log("EditApplication.sendActions(): entered"),va?(q.log("EditApplication.sendActions(): sending in progress - using current promise"),$.when(c,Oa)):Ta?(q.error("EditApplication.sendActions(): internal error detected - promise rejected!"),$.Deferred().reject()):0===ta.length?(q.log("EditApplication.sendActions(): no need to send action buffer empty"),$.when(Oa)):(c=$.Deferred().always(function(){q.log("EditApplication.sendActions(): current send promise resolved - sendingActions = false"),va=!1,C()}),va=!0,C(),b(),$.when(c,Oa))}}(),Hb=function(){function a(a){var b=!1;q.debug&&q.log(a.operations.length>0?"EditApplication.storeAction(): last action: "+JSON.stringify(_.last(a.operations)):"EditApplication.storeAction(): no actions provided"),Ga&&wb.length>0&&(ta=Ga.call(na,ta,wb),Ga=null,wb=[],b=!0),!Ta&&(a.operations.length>0||b)&&(a.operations.length>0&&ta.push(a),Ma=!0,C())}return na.createDebouncedMethod(a,Gb,{delay:Ia,maxDelay:5*Ia,infoString:"EditApplication: sendActions"})}();this.leaveBusyDuringImport=_.once(function(a){return lb=_.now(),Db("previewStart"),C(),pa.showAfterImport(a)}),this.createDebouncedActionsMethodFor=function(a,b,c,d){function e(){return a.destroyed?void 0:oa.isProcessingActions()?void(f||(f=!0,a.waitForAny(oa.getActionsPromise(),function(){f=!1,c.call(a)}))):void c.call(a)}var f=!1;return d||(d={}),d.infoString||(d.infoString="EditApplication: invokeDeferredCallback"),this.createDebouncedMethod(_.bind(b,a),e,d)},this.getFileFormat=function(){return this.hasFileDescriptor()&&n.getFileFormat(this.getFullFileName())},this.isOOXML=function(){return this.hasFileDescriptor()&&n.isOfficeOpenXML(this.getFullFileName())},this.isODF=function(){return this.hasFileDescriptor()&&n.isOpenDocument(this.getFullFileName())},this.isTemplateFile=function(){return this.hasFileDescriptor()&&n.isTemplate(this.getFullFileName())},this.isScriptable=function(){return this.hasFileDescriptor()&&n.isScriptable(this.getFullFileName())},this.getClientId=function(){return qa},this.getEditClientId=function(){return Xa},this.getClientOperationName=function(){return ra},this.getPendingActions=function(){return ta},this.getActiveClients=function(){return ib},this.isLocallyModified=function(){return Ma},this.isPrepareLosingEditRights=function(){return Ya},this.sendRealTimeQuery=function(a,b){return _.isNumber(b)||(b=2e4),sa.sendQuery(a,b)},this.sendActionRequest=function(a,c,d){return d=_.extend({method:"POST"},d),this.sendFileRequest(b.FILTER_MODULE_NAME,{action:a,requestdata:JSON.stringify(c),rtdata:JSON.stringify({rtid:sa.getUuid(),session:ox.session})},d)},this.sendQueryRequest=function(a,b,c){return this.sendActionRequest("query",_.extend({},b,{type:a}),c)},this.applyUpdateMessageData=function(b){return _.isObject(b)?(ia(b),Fb(b,{notify:!0})):(a.error("EditApplication.applyUpdateMessageData(): invalid response (object expected):",b),this.setInternalError(i.ERROR_WHILE_MODIFYING_DOCUMENT,g.GENERAL),$.Deferred().reject())},this.sendLogMessage=o.LOG_ERROR_DATA?function(a){return sa&&sa.sendLogMessage(a),this}:a.NOOP,this.rename=function(b){var c=this.getFileDescriptor(),d=a.getStringOption(c,"filename",this.getFullFileName()),e=a.getStringOption(c,"com.openexchange.file.sanitizedFilename",d),h=a.trimAndCleanString(b),i=a.getActiveElement();return Oa?(a.warn("EditDocument.rename(): multiple calls, ignoring subsequent call"),Oa):0===h.length?$.Deferred().reject():h===this.getShortFileName()?$.when():(h+="."+this.getFileExtension(),this.updateFileDescriptor({filename:h}),xb=$.Deferred(),Oa=$.when(Ea.call(na)).then(Gb).then(function(){return na.sendActionRequest("renamedocument",{target_filename:h})}),Oa=Oa.then(function(a){var b=new f(a);return b.isWarning()&&"RENAMEDOCUMENT_SAVE_IN_PROGRESS_WARNING"===b.getCodeAsConstant()?xb.promise():b.isError()?$.Deferred().reject(b):a}),Oa.done(function(b){Pa=!0,na.updateFileDescriptor({filename:a.getStringOption(b,"fileName",d),"com.openexchange.file.sanitizedFilename":a.getStringOption(b,"com.openexchange.file.sanitizedFilename",e)})}),Oa.fail(function(b){var c=null,e=f.isErrorCode(b)?b:new f(b);"abort"!==b&&(e.setErrorContext(g.RENAME),c=k.getMessageData(e),a.warn("EditApplication.rename() error: "+e.getErrorText()),pa.yell(c)),na.updateFileDescriptor({filename:d})}),Oa.always(function(){Oa=null,_.browser.IE&&i&&i.focus()}),Oa)},this.hasUnsavedChanges=function(){return va||!!Oa||ta.length>0||_.isObject(ua)},this.saveChanges=function(){return Gb()},this.getState=function(){return Ja},this.isOffline=function(){return"offline"===Ja},this.isInternalError=function(){return"error"===Ja},this.setInternalError=function(b,c,d,e){var g=f.isErrorCode(b)?b:new f(b),h=null,i=null,j=null,l=!0,m=a.getObjectOption(e,"additionalData",{}),n=f.isErrorCode(d)?d:_.isString(d)?new f(d):g;_.isString(c)&&g.setErrorContext(c),h=na.getErrorState(),_.isObject(h)&&h.isError()||na.setErrorState(g),j=na.getErrorState(),f.isErrorCode(j)&&a.error("Internal error: "+j.getErrorText()),g.isError()?(Ta=!0,Ka=!1,Ra=!0,oa.setEditMode(!1)):(l=!_.has(sb,g.getCodeAsConstant()),sb[g.getCodeAsConstant()]=!0),C(),i=k.getMessageData(g,_.extend({causeError:n},E(),m)),na.extendMessageData(i),D(i),a.getBooleanOption(e,"showMessage",!0)&&l&&pa.yell(i)},this.setCurrentInfoState=function(b,c){var d=null,e=a.getBooleanOption(c,"showMessage",!0);na.setInfoState(b),e&&(d=l.getMessageData(b,_.extend({},E(),c)),na.extendMessageData(d),_.isObject(d)&&pa.yell(d))},this.isLocked=function(){return Ta||Ra},this.isAcquireEditRightsEnabled=function(){return _.isObject(sa)&&!this.isLocked()&&!this.isOffline()&&!oa.getEditMode()},this.acquireEditRights=_.throttle(function(){this.isAcquireEditRightsEnabled()&&(sa.acquireEditRights(),P("acquire"))},3e3),this.isReloadEnabled=function(){return Bb},this.isAutoSaveEnabled=function(){return!0},this.toggleAutoSave=function(){return pa.yell({type:"info",headline:t("What is AutoSave?"),message:t("In OX Documents all your changes are saved automatically through AutoSave. It is not necessary to save your work manually.")}),this},this.saveDocumentAs=function(b,c,d){var h=null,i=_.isString(b)?a.trimAndCleanString(b):"",l=null;return 0===i.length?$.Deferred().reject():(h=this.sendActionRequest("copydocument",{file_id:na.getFileParameters().id,target_filename:i,asTemplate:"template"===d,target_folder_id:c}),h=h.then(function(a){var b=new f(a);return b.isError()?$.Deferred().reject(b):a}),h=h.then(function(a){return e.getPath(c).then(function(b){return l=e.preparePath(b),a})}),h.then(function(b){var f=a.getStringOption(b,"folder_id",null),g=a.getStringOption(b,"filename",i);oa.setEditMode(!1),"template"===d&&na.setCurrentInfoState(j.INFO_DOC_SAVED_AS_TEMPLATE,{fullFileName:g,fullPathName:l,type:"success",duration:1e4});var h=a.getStringOption(b,"id",null),k=c||f;return e.getFile({id:h,folder_id:k}).then(function(a){a.title=n.getBaseName(a.fileName),na.updateFileDescriptor(a),y.action="load",delete y.template,na.reloadDocument()})}),h.fail(function(b){var c=null;b=f.isErrorCode(b)?b:new f(f.GENERAL_ERROR),b.setErrorContext(g.SAVEAS),c=k.getMessageData(b,E()),a.warn('EditApplication.saveDocumentAs(): Error code "'+b.getCodeAsConstant()+'"'),pa.yell({type:c.type,headline:c.headline,message:c.message})}),h.promise())},this.reloadDocument=function(){var b=this.getFileDescriptor(),c=this.getFullFileName(),d=n.getEditModule(c);return d?n.isNative(c)?void this.quit("reload").done(function(){_.delay(function(){ox.launch(d+"/main",{action:"load",file:b})},1e3)}):(a.error("EditApplication.reloadDocument(): unsupported document type"),this):(a.error("EditApplication.reloadDocument(): unknown application type"),this)},this.restoreDocument=function(c,d){function g(a,b){var c={},d=s.getActionsArray(a),e=s.getActionsArray(b);return c=_.isArray(d)&&_.isArray(e)?d.concat(e):d}var i=a.getArrayOption(d,"actions",null),j=na.getFileDescriptor(),k=null;if(!Ab)return void na.setInternalError(c);if(!zb){zb=!0,k=_.isNull(i)?g(sa.getPendingActions(),na.getPendingActions()):i,Ra=!0,oa.setEditMode(!1),C(),Ta=!0;var l=na.sendFileRequest(b.FILTER_MODULE_NAME,{action:"saveaswithbackup",file_id:j.id,target_filename:j.fileName,target_folder_id:j.folder_id,restore_id:yb,operations:_.isNull(k)?k:JSON.stringify(k)},{method:"POST"});l.then(function(b){var d=new f(b),g=$.Deferred(),i=a.getStringOption(b,h.RESTORED_FILEID,null),j=a.getStringOption(b,h.RESTORED_FILENAME,null),k=a.getStringOption(b,h.RESTORED_FOLDERID,null),l=null,m={};_.isObject(b)&&_.isString(j)&&_.isString(k)?e.getPath(k).always(function(a){l=e.preparePath(a),g.resolve(l)}):g.resolve(null),g.always(function(a){var b=_.isString(a);d.isError()||(d=new f({errorClass:f.ERRORCLASS_ERROR,error:"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"})),m[h.RESTORED_FILENAME]=j,m[h.RESTORED_PATHNAME]=l,m[h.ORIGINAL_FILEID]=na.getFileDescriptor().id,b&&na.updateFileDescriptor({id:i,folder_id:k}),na.setInternalError(d,c.getErrorContext(),c,{additionalData:m})})},function(){na.setInternalError(c)})}},this.rejectEditAttempt=function(a){switch(a){case"image":pa.yell({type:"warning",message:t("The image could not be inserted.")});break;case"formula":pa.yell({type:"warning",message:t("The formula could not be inserted.")});break;case"siri":na.setInternalError(i.ERROR_SIRI_NOT_SUPPORTED,g.GENERAL);break;case"clipboardTimeout":na.setInternalError(i.ERROR_CLIPBOARD_TIMEOUT,g.GENERAL);break;case"loadingInProgress":na.setCurrentInfoState(j.INFO_LOADING_IN_PROGRESS);break;case"android-ime":na.setInternalError(i.ERROR_ANDROID_IME_NOT_SUPPORTED_KEYBOARD,g.GENERAL);break;default:na.isImportFinished()?F():na.setCurrentInfoState(j.INFO_LOADING_IN_PROGRESS)}return this},this.updateUserData=function(){function a(a){return c=a,this}function b(){!sa||Ta||na.isInQuit()||sa.updateUserData("updateuserdata",c)}var c=null;return na.createDebouncedMethod(a,b,{delay:500,maxDelay:1e3,infoString:"EditApplication: sendUserData"})}(),this.getAuthorColorIndex=function(b){return a.getSchemeColor(ma(b))},this.addAuthors=function(a){return tb=_.union(tb,a),this},this.stopOperationDistribution=function(a){ub=!1,_.isFunction(a)&&a.call(na),ub=!0},this.isOperationsBlockActive=function(){return vb},this.enterBlockOperationsMode=function(a){vb=!0,ua&&ua.operations&&ua.operations.length>0&&(na.trigger("operations:remove",ua.operations.length),ua=ea()),_.isFunction(a)&&a.call(na),vb=!1},this.debugTriggerRealtimeEvent=o.DEBUG?function(a){return sa.trigger(a),this}:$.noop,this.debugSendInvalidOperation=o.DEBUG?function(b){var c=a.getBooleanOption(b,"badOsn",!1),d=[],e=c?oa.getOperationStateNumber()+1e3:oa.getOperationStateNumber(),f=a.getObjectOption(b,"operation",null);return f&&(f=_.extend(f,{osn:e,opl:1}),d.push(f),c||oa.setOperationStateNumber(e+1),sa.sendActions([{operations:d}])),this}:$.noop,this.debugQuit=o.DEBUG?function(a){switch(a){case"unsaved":var b=na.hasUnsavedChanges;this.hasUnsavedChanges=_.constant(!0),this.quit().fail(function(){na.hasUnsavedChanges=b});break;case"error":sa.closeDocument=function(){var a=$.Deferred();return _.delay(function(){a.reject()},2e3),a},this.quit()}}:$.noop,this.getLaunchOption=function(b){return a.getOption(y,b)},this.onInit(function(){oa=na.getModel(),pa=na.getView(),na.waitForImport(function(){mb=_.now()}),C(),oa.on("readonly",C),!n.supportsEditMode(na.getDocumentType())||_.browser.Android&&!a.supportedChromeVersionOnAndroidForText()?(Ra=!0,oa.setEditMode(!1),F(t("Support starts with Chrome %1$d, Firefox %2$d, IE %3$d, and Safari %4$d.",49,43,11,8),-1)):na.attributes&&"io.ox/office/spreadsheet"===na.attributes.name||!_.browser.MacOS||!_.browser.Chrome||a.supportedChromeVersionOnMacForText()||(Ra=!0,oa.setEditMode(!1),F(t("Support starts with Chrome %1$d, Firefox %2$d, IE %3$d, and Safari %4$d.",53,43,11,8),-1)),_a&&cb&&(a.info("EditApplication.onInit(): saving document to local storage is active"),db?a.info("EditApplication.onInit(): current browser supports local storage"):a.warn("EditApplication.onInit(): current browser does not support local storage"))}),this.registerBeforeQuitHandler(ga).registerQuitHandler(ha),this.registerDestructor(function(){y=z=na=oa=pa=null,sa=ta=ua=wb=null,wa=xa=ya=null,za=Aa=Ba=null,Ca=Da=Fa=Ga=Ha=null,Oa=fb=hb=ib=null,jb=kb=null})}});return y});