define("io.ox/office/spreadsheet/model/formula/formulautils",["io.ox/office/tk/utils","io.ox/office/tk/utils/logger","io.ox/office/spreadsheet/utils/errorcode"],function(a,b,c){"use strict";function d(a){var b=new c(a);return b.internal=!0,b}var e={};return b.extend(e,{enable:"spreadsheet:log-formulas",prefix:"FMLA"}),e.MAX_PARAM_COUNT=254,e.MAX_MATRIX_ROW_COUNT=16,e.MAX_MATRIX_COL_COUNT=16,e.MAX_REF_LIST_SIZE=1024,e.MAX_CELL_ITERATION_COUNT=2e3,e.UNSUPPORTED_ERROR=d("unsupported"),e.CIRCULAR_ERROR=d("circular"),e.INTERNAL_ERROR=d("internal"),e.throwErrorCode=function(a){if(a instanceof c)throw a;return a},e.throwInternal=function(b){throw a.error(b),e.INTERNAL_ERROR},e.trunc=function(a){return 0>a?Math.ceil(a):Math.floor(a)},e.add=function(a,b){return a+b},e.multiply=function(a,b){return a*b},e.divide=function(a,b){if(0===b)throw c.DIV0;return a/b},e.modulo=function(a,b){if(0===b)throw c.DIV0;var d=a%b;return 0!==d&&0>a*b?d+b:d},e.powerOOXML=function(a,b){if(0===a&&0===b)throw c.NUM;if(0===a&&0>b)throw c.DIV0;return Math.pow(a,b)},e.powerODF=function(a,b){if(0===a&&0>b)throw c.NUM;return Math.pow(a,b)},e.POWER={ooxml:e.powerOOXML,odf:e.powerODF},e.arctan2=function(a,b){if(0===a&&0===b)throw c.DIV0;return Math.atan2(b,a)},e.sinh=Math.sinh||function(a){return(Math.exp(a)-Math.exp(-a))/2},e.cosh=Math.cosh||function(a){return(Math.exp(a)+Math.exp(-a))/2},e.tanh=Math.tanh||function(a){var b=Math.exp(a),c=Math.exp(-a);return(b-c)/(b+c)},e.asinh=Math.asinh||function(a){return Math.log(a+Math.sqrt(a*a+1))},e.acosh=Math.acosh||function(a){return Math.log(a+Math.sqrt(a*a-1))},e.atanh=Math.atanh||function(a){return Math.log((1+a)/(1-a))/2},e.acoth=Math.acoth||function(a){return Math.log((a+1)/(a-1))/2},e.compareNumbers=function(b,c){var d=b-c,e=Math.abs(d);return isFinite(d)?e<a.MIN_NUMBER?0:d/e:Number.NaN},e.compareStrings=function(b,c,d){if(a.getBooleanOption(d,"withCase",!1)){var f=Math.min(b.length,c.length);if(b.substr(0,f)===c.substr(0,f))return e.compareNumbers(b.length,c.length);for(var g=0;f>g;g+=1){var h=b[g],i=c[g];if(h!==i){var j=h.toUpperCase(),k=i.toUpperCase();return k>j?-1:j>k?1:h!==j&&i===k?-1:1}}return a.error("FormulaUtils.compareStrings(): unexpected end of strings"),0}return b=b.toUpperCase(),c=c.toUpperCase(),c>b?-1:b>c?1:0},e.compareBooleans=function(a,b){return a-b},e.compareErrorCodes=function(a,b){return e.compareNumbers(a.num,b.num)},e.compareValues=function(b,d,f){function g(a){return _.isNumber(a)?0:_.isString(a)?"":_.isBoolean(a)?!1:null}function h(a){return _.isNumber(a)?1:_.isString(a)?2:_.isBoolean(a)?3:a instanceof c?4:0}a.getBooleanOption(f,"convertNull",!1)&&(_.isNull(b)&&(b=g(d)),_.isNull(d)&&(d=g(b)));var i=h(b),j=h(d);if(i!==j)return e.compareNumbers(i,j);switch(i){case 1:return e.compareNumbers(b,d);case 2:return e.compareStrings(b,d,f);case 3:return e.compareBooleans(b,d);case 4:return e.compareErrorCodes(b,d)}return 0},e.isValidMatrixSize=function(a,b){return a>0&&a<=e.MAX_MATRIX_ROW_COUNT&&b>0&&b<=e.MAX_MATRIX_COL_COUNT},e.ensureMatrixSize=function(a,b){if(!e.isValidMatrixSize(a,b))throw e.UNSUPPORTED_ERROR},e.implementNumericAggregation=function(a,b,c,d){return function(){return this.aggregateNumbers(arguments,a,b,c,d)}},e.implementNumericAggregationWithArray=function(a,b){return function(){function c(a,b){return e.push(b),a+b}function d(b){return a.call(this,e,b)}var e=[];return this.aggregateNumbers(arguments,0,c,d,b)}},e.implementFilterAggregation=function(a,b,c){return function(d,e,f){return this.aggregateFiltered(d,e,f,a,b,c)}},e.valueToString=function(a){return _.isString(a)?'"'+a.replace(/"/g,'""')+'"':a instanceof Date?a.toISOString():_.isNull(a)?"null":_.isBoolean(a)?a.toString().toUpperCase():a.toString()},e.logTokens=e.isLoggingActive()?function(a,b){e.log(a+": "+b.join(" "))}:$.noop,e.factorial=function(){for(var a=[],b=1;isFinite(b);)a.push(b),b*=a.length;return function(b){var d=a[Math.floor(b)];if(!d)throw c.NUM;return d}}(),e});