define("io.ox/office/spreadsheet/model/formula/impl/statisticalfuncs",["io.ox/office/tk/utils","io.ox/office/spreadsheet/utils/errorcode","io.ox/office/spreadsheet/model/formula/formulautils"],function(a,b,c){"use strict";function d(a,b){function d(a){return isFinite(a)?a:0}var e="max"===a?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY,f=_.bind(Math[a],Math);return c.implementNumericAggregation(e,f,d,b)}function e(b,d,e){function f(e,f){var g=c.divide(f,e.length),h=a.getSum(e,function(a){var b=a-g;return b*b}),i=d?e.length:e.length-1;return h=c.divide(h,i),"dev"===b?Math.sqrt(h):h}return c.implementNumericAggregationWithArray(f,e)}var f={valMode:"convert",matMode:"skip",refMode:"skip",emptyParam:!0,complexRef:!0},g={valMode:"convert",matMode:"skip",refMode:"zero",emptyParam:!0,complexRef:!0},h={valMode:"convert",matMode:"zero",refMode:"zero",emptyParam:!0,complexRef:!0};return{AVEDEV:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:function(){function d(c,d){if(0===c.length)throw b.NUM;var e=d/c.length;return a.getSum(c,function(a){return Math.abs(a-e)})/c.length}return c.implementNumericAggregationWithArray(d,f)}()},AVERAGE:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:c.implementNumericAggregation(0,c.add,c.divide,f)},AVERAGEA:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:c.implementNumericAggregation(0,c.add,c.divide,h)},AVERAGEIF:{category:"statistical",ceName:null,minParams:2,maxParams:3,type:"val",signature:"ref val:any ref",resolve:c.implementFilterAggregation(0,c.add,c.divide)},AVERAGEIFS:{category:"statistical",ceName:null,minParams:3,repeatParams:2,type:"val",signature:"ref ref val:any"},"BETA.DIST":{category:"statistical",name:{ooxml:"_xlfn.BETA.DIST",odf:"COM.MICROSOFT.BETA.DIST"},ceName:null,minParams:4,maxParams:6,type:"val"},"BETA.INV":{category:"statistical",name:{ooxml:"_xlfn.BETA.INV",odf:"COM.MICROSOFT.BETA.INV"},ceName:null,minParams:3,maxParams:5,type:"val"},BETADIST:{category:"statistical",minParams:3,maxParams:5,type:"val"},BETAINV:{category:"statistical",minParams:3,maxParams:5,type:"val"},"BINOM.DIST":{category:"statistical",name:{ooxml:"_xlfn.BINOM.DIST",odf:"COM.MICRSOFT.BINOM.DIST"},ceName:null,minParams:4,maxParams:4,type:"val"},"BINOM.DIST.RANGE":{category:"statistical",name:{ooxml:"_xlfn.BINOM.DIST.RANGE",odf:["BINOM.DIST.RANGE","B"]},ceName:{ooxml:null,odf:"B"},minParams:3,maxParams:4,type:"val"},"BINOM.INV":{category:"statistical",name:{ooxml:"_xlfn.BINOM.INV",odf:"COM.MICRSOFT.BINOM.INV"},ceName:null,minParams:3,maxParams:3,type:"val"},BINOMDIST:{category:"statistical",minParams:4,maxParams:4,type:"val"},CHIDIST:{category:"statistical",name:{odf:"LEGACY.CHIDIST"},minParams:2,maxParams:2,type:"val"},CHIINV:{category:"statistical",name:{odf:"LEGACY.CHIINV"},minParams:2,maxParams:2,type:"val"},"CHISQ.DIST":{category:"statistical",name:{ooxml:"_xlfn.CHISQ.DIST",odf:"COM.MICROSOFT.CHISQ.DIST"},ceName:{odf:null},minParams:3,maxParams:3,type:"val"},"CHISQ.DIST.RT":{category:"statistical",name:{ooxml:"_xlfn.CHISQ.DIST.RT",odf:"COM.MICROSOFT.CHISQ.DIST.RT"},ceName:null,minParams:2,maxParams:2,type:"val"},"CHISQ.INV":{category:"statistical",name:{ooxml:"_xlfn.CHISQ.INV",odf:"COM.MICROSOFT.CHISQ.INV"},ceName:{odf:null},minParams:2,maxParams:2,type:"val"},"CHISQ.INV.RT":{category:"statistical",name:{ooxml:"_xlfn.CHISQ.INV.RT",odf:"COM.MICROSOFT.CHISQ.INV.RT"},ceName:null,minParams:2,maxParams:2,type:"val"},"CHISQ.TEST":{category:"statistical",name:{ooxml:"_xlfn.CHISQ.TEST",odf:"COM.MICROSOFT.CHISQ.TEST"},ceName:null,minParams:2,maxParams:2,type:"val"},CHISQDIST:{category:"statistical",name:{ooxml:null},ceName:{ooxml:null},minParams:2,maxParams:3,type:"val"},CHISQINV:{category:"statistical",name:{ooxml:null},ceName:{ooxml:null},minParams:2,maxParams:2,type:"val"},CHITEST:{category:"statistical",name:{odf:"LEGACY.CHITEST"},minParams:2,maxParams:2,type:"val"},CONFIDENCE:{category:"statistical",minParams:3,maxParams:3,type:"val"},"CONFIDENCE.NORM":{category:"statistical",name:{ooxml:"_xlfn.CONFIDENCE.NORM",odf:"COM.MICROSOFT.CONFIDENCE.NORM"},ceName:null,minParams:3,maxParams:3,type:"val"},"CONFIDENCE.T":{category:"statistical",name:{ooxml:"_xlfn.CONFIDENCE.T",odf:"COM.MICROSOFT.CONFIDENCE.T"},ceName:null,minParams:3,maxParams:3,type:"val"},CORREL:{category:"statistical",minParams:2,maxParams:2,type:"val"},COUNT:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:function(){var a=0;return this.iterateOperands(0,function(b){if(b.isValue())try{this.convertToNumber(b.getValue()),a+=1}catch(c){}else this.iterateValues(b,function(b){_.isNumber(b)&&(a+=1)},{acceptErrors:!0,complexRef:!0})}),a}},COUNTA:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:function(){var a=0;return this.iterateOperands(0,function(b){switch(b.getType()){case"val":a+=1;break;case"mat":a+=b.getMatrix().size();break;case"ref":this.iterateValues(b,function(){a+=1},{acceptErrors:!0,complexRef:!0})}}),a}},COUNTBLANK:{category:"statistical",minParams:1,maxParams:1,type:"val",signature:"ref",resolve:function(a){var b=0,c="ooxml"===this.getFileFormat();return this.iterateValues(a,function(a){c&&""===a||(b+=1)},{acceptErrors:!0,complexRef:!1}),a.cells()-b}},COUNTIF:{category:"statistical",minParams:2,maxParams:2,type:"val",signature:"ref val:any",resolve:c.implementFilterAggregation(0,_.identity,function(a,b,c){return c})},COUNTIFS:{category:"statistical",ceName:null,minParams:2,repeatParams:2,type:"val"},COVAR:{category:"statistical",minParams:2,maxParams:2,type:"val"},"COVARIANCE.P":{category:"statistical",name:{ooxml:"_xlfn.COVARIANCE.P",odf:"COM.MICROSOFT.COVARIANCE.P"},ceName:null,minParams:2,maxParams:2,type:"val"},"COVARIANCE.S":{category:"statistical",name:{ooxml:"_xlfn.COVARIANCE.S",odf:"COM.MICROSOFT.COVARIANCE.S"},ceName:null,minParams:2,maxParams:2,type:"val"},CRITBINOM:{category:"statistical",minParams:3,maxParams:3,type:"val"},DEVSQ:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:function(){function d(c,d){if(0===c.length)throw b.NUM;var e=d/c.length;return a.getSum(c,function(a){var b=a-e;return b*b})}return c.implementNumericAggregationWithArray(d,f)}()},"EXPON.DIST":{category:"statistical",name:{ooxml:"_xlfn.EXPON.DIST",odf:"COM.MICROSOFT.EXPON.DIST"},ceName:null,minParams:3,maxParams:3,type:"val"},EXPONDIST:{category:"statistical",minParams:3,maxParams:3,type:"val"},"F.DIST":{category:"statistical",name:{ooxml:"_xlfn.F.DIST",odf:["FDIST","COM.MICROSOFT.F.DIST"]},ceName:null,minParams:4,maxParams:4,type:"val"},"F.DIST.RT":{category:"statistical",name:{ooxml:"_xlfn.F.DIST.RT",odf:"COM.MICROSOFT.F.DIST.RT"},ceName:null,minParams:4,maxParams:4,type:"val"},"F.INV":{category:"statistical",name:{ooxml:"_xlfn.F.INV",odf:["FINV","COM.MICROSOFT.F.INV"]},ceName:null,minParams:3,maxParams:3,type:"val"},"F.INV.RT":{category:"statistical",name:{ooxml:"_xlfn.F.INV.RT",odf:"COM.MICROSOFT.F.INV.RT"},ceName:null,minParams:3,maxParams:3,type:"val"},"F.TEST":{category:"statistical",name:{ooxml:"_xlfn.F.TEST",odf:"COM.MICROSOFT.F.TEST"},ceName:null,minParams:3,maxParams:3,type:"val"},FDIST:{category:"statistical",name:{odf:"LEGACY.FDIST"},minParams:3,maxParams:3,type:"val"},FINV:{category:"statistical",name:{odf:"LEGACY.FINV"},minParams:3,maxParams:3,type:"val"},FISHER:{category:"statistical",minParams:1,maxParams:1,type:"val"},FISHERINV:{category:"statistical",minParams:1,maxParams:1,type:"val"},FORECAST:{category:"statistical",minParams:3,maxParams:3,type:"val"},FREQUENCY:{category:"statistical",minParams:2,maxParams:2,type:"mat"},FTEST:{category:"statistical",minParams:2,maxParams:2,type:"val"},GAMMA:{category:"statistical",name:{ooxml:"_xlfn.GAMMA"},minParams:1,maxParams:1,type:"val"},"GAMMA.DIST":{category:"statistical",name:{ooxml:"_xlfn.GAMMA.DIST",odf:"COM.MICROSOFT.GAMMA.DIST"},ceName:null,minParams:4,maxParams:4,type:"val"},"GAMMA.INV":{category:"statistical",name:{ooxml:"_xlfn.GAMMA.INV",odf:"COM.MICROSOFT.GAMMA.INV"},ceName:null,minParams:3,maxParams:3,type:"val"},GAMMADIST:{category:"statistical",minParams:4,maxParams:4,type:"val"},GAMMAINV:{category:"statistical",minParams:3,maxParams:3,type:"val"},GAMMALN:{category:"statistical",minParams:1,maxParams:1,type:"val"},"GAMMALN.PRECISE":{category:"statistical",name:{ooxml:"_xlfn.GAMMALN.PRECISE",odf:"COM.MICROSOFT.GAMMALN.PRECISE"},ceName:null,minParams:1,maxParams:1,type:"val"},GAUSS:{category:"statistical",name:{ooxml:"_xlfn.GAUSS"},minParams:1,maxParams:1,type:"val"},GEOMEAN:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:function(){function a(a,c){if(0===a||0===c)throw b.NUM;return Math.pow(a,1/c)}return c.implementNumericAggregation(1,c.multiply,a,f)}()},GROWTH:{category:"statistical",minParams:1,maxParams:4,type:"mat"},HARMEAN:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:function(){function a(a,c){if(0===c)throw b.NUM;return a+1/c}function d(a,c){if(0===c)throw b.NA;return c/a}return c.implementNumericAggregation(0,a,d,f)}()},"HYPGEOM.DIST":{category:"statistical",name:{ooxml:"_xlfn.HYPGEOM.DIST",odf:"COM.MICROSOFT.HYPGEOM.DIST"},ceName:null,minParams:5,maxParams:5,type:"val"},HYPGEOMDIST:{category:"statistical",minParams:4,maxParams:4,type:"val"},INTERCEPT:{category:"statistical",minParams:2,maxParams:2,type:"val"},KURT:{category:"statistical",minParams:1,type:"val"},LARGE:{category:"statistical",minParams:2,maxParams:2,type:"val"},LINEST:{category:"statistical",minParams:1,maxParams:4,type:"mat"},LOGEST:{category:"statistical",minParams:1,maxParams:4,type:"mat"},LOGINV:{category:"statistical",minParams:3,maxParams:3,type:"val"},"LOGNORM.DIST":{category:"statistical",name:{ooxml:"_xlfn.LOGNORM.DIST",odf:"COM.MICROSOFT.LOGNORM.DIST"},ceName:null,minParams:4,maxParams:4,type:"val"},"LOGNORM.INV":{category:"statistical",name:{ooxml:"_xlfn.LOGNORM.INV",odf:"COM.MICROSOFT.LOGNORM.INV"},ceName:null,minParams:3,maxParams:3,type:"val"},LOGNORMDIST:{category:"statistical",minParams:3,maxParams:3,type:"val"},MAX:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:d("max",f)},MAXA:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:d("max",g)},MEDIAN:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:function(){function a(a){var c=a.length;if(0===c)throw b.NUM;return a=_.sortBy(a),c%2===0?(a[c/2-1]+a[c/2])/2:a[(c-1)/2]}return c.implementNumericAggregationWithArray(a,f)}()},MIN:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:d("min",f)},MINA:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:d("min",g)},MODE:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:function(){function a(a){if(0===a.length)throw b.NA;var c=_.countBy(a),d=_.reduce(c,function(a,b){return Math.max(a,b)},0),e={};if(1===d)throw b.NA;return _.each(c,function(a,b){a===d&&(e[b]=!0)}),_.find(a,function(a){return a in e})}return c.implementNumericAggregationWithArray(a,{valMode:"exact",matMode:"skip",refMode:"exact",emptyParam:!0,complexRef:!1})}()},"MODE.SNGL":{category:"statistical",name:{ooxml:"_xlfn.MODE.SNGL",odf:"COM.MICROSOFT.MODE.SNGL"},minParams:1,type:"val",signature:"any",resolve:"MODE"},"MODE.MULT":{category:"statistical",name:{ooxml:"_xlfn.MODE.MULT",odf:"COM.MICROSOFT.MODE.MULT"},ceName:null,minParams:1,type:"mat"},"NEGBINOM.DIST":{category:"statistical",name:{ooxml:"_xlfn.NEGBINOM.DIST",odf:"COM.MICROSOFT.NEGBINOM.DIST"},ceName:null,minParams:4,maxParams:4,type:"val"},NEGBINOMDIST:{category:"statistical",minParams:3,maxParams:3,type:"val"},"NORM.DIST":{category:"statistical",name:{ooxml:"_xlfn.NORM.DIST",odf:"COM.MICROSOFT.NORM.DIST"},ceName:null,minParams:4,maxParams:4,type:"val"},"NORM.INV":{category:"statistical",name:{ooxml:"_xlfn.NORM.INV",odf:"COM.MICROSOFT.NORM.INV"},ceName:null,minParams:3,maxParams:3,type:"val"},"NORM.S.DIST":{category:"statistical",name:{ooxml:"_xlfn.NORM.S.DIST",odf:"COM.MICROSOFT.NORM.S.DIST"},ceName:null,minParams:2,maxParams:2,type:"val"},"NORM.S.INV":{category:"statistical",name:{ooxml:"_xlfn.NORM.S.INV",odf:"COM.MICROSOFT.NORM.S.INV"},ceName:null,minParams:1,maxParams:1,type:"val"},NORMDIST:{category:"statistical",minParams:4,maxParams:4,type:"val"},NORMINV:{category:"statistical",minParams:3,maxParams:3,type:"val"},NORMSDIST:{category:"statistical",minParams:1,maxParams:1,type:"val"},NORMSINV:{category:"statistical",minParams:1,maxParams:1,type:"val"},PEARSON:{category:"statistical",minParams:2,maxParams:2,type:"val"},PERCENTILE:{category:"statistical",minParams:2,maxParams:2,type:"val"},"PERCENTILE.EXC":{category:"statistical",name:{ooxml:"_xlfn.PERCENTILE.EXC",odf:"COM.MICROSOFT.PERCENTILE.EXC"},ceName:null,minParams:2,maxParams:2,type:"val"},"PERCENTILE.INC":{category:"statistical",name:{ooxml:"_xlfn.PERCENTILE.INC",odf:"COM.MICROSOFT.PERCENTILE.INC"},ceName:null,minParams:2,maxParams:2,type:"val"},PERCENTRANK:{category:"statistical",minParams:2,maxParams:{ooxml:3,odf:2},type:"val"},"PERCENTRANK.EXC":{category:"statistical",name:{ooxml:"_xlfn.PERCENTRANK.EXC",odf:"COM.MICROSOFT.PERCENTRANK.EXC"},ceName:null,minParams:2,maxParams:3,type:"val"},"PERCENTRANK.INC":{category:"statistical",name:{ooxml:"_xlfn.PERCENTRANK.INC",odf:"COM.MICROSOFT.PERCENTRANK.INC"},ceName:null,minParams:2,maxParams:3,type:"val"},PERMUT:{category:"statistical",minParams:2,maxParams:2,type:"val",signature:"val:int val:int",resolve:function(a,d){if(0>=a)throw b.NUM;if(0>=d)throw b.NUM;if(d>a)throw b.NUM;return c.factorial(a)/c.factorial(a-d)}},PERMUTATIONA:{category:"statistical",name:{ooxml:"_xlfn.PERMUTATIONA"},minParams:2,maxParams:2,type:"val",signature:"val:int val:int",resolve:function(a,c){if(0>a)throw b.NUM;if(0>c)throw b.NUM;return Math.pow(a,c)}},PHI:{category:"statistical",name:{ooxml:"_xlfn.PHI"},minParams:1,maxParams:1,type:"val"},POISSON:{category:"statistical",minParams:3,maxParams:3,type:"val"},"POISSON.DIST":{category:"statistical",name:{ooxml:"_xlfn.POISSON.DIST",odf:"COM.MICROSOFT.POISSON.DIST"},ceName:null,minParams:3,maxParams:3,type:"val"},PROB:{category:"statistical",minParams:3,maxParams:4,type:"val"},QUARTILE:{category:"statistical",minParams:2,maxParams:2,type:"val"},"QUARTILE.EXC":{category:"statistical",name:{ooxml:"_xlfn.QUARTILE.EXC",odf:"COM.MICROSOFT.QUARTILE.EXC"},ceName:null,minParams:2,maxParams:2,type:"val"},"QUARTILE.INC":{category:"statistical",name:{ooxml:"_xlfn.QUARTILE.INC",odf:"COM.MICROSOFT.QUARTILE.INC"},ceName:null,minParams:2,maxParams:2,type:"val"},RANK:{category:"statistical",minParams:2,maxParams:3,type:"val"},"RANK.AVG":{category:"statistical",name:{ooxml:"_xlfn.RANK.AVG",odf:"COM.MICROSOFT.RANK.AVG"},ceName:null,minParams:2,maxParams:3,type:"val"},"RANK.EQ":{category:"statistical",name:{ooxml:"_xlfn.RANK.EQ",odf:"COM.MICROSOFT.RANK.EQ"},ceName:null,minParams:2,maxParams:3,type:"val"},RSQ:{category:"statistical",minParams:2,maxParams:2,type:"val"},SKEW:{category:"statistical",minParams:1,type:"val"},"SKEW.P":{category:"statistical",name:{ooxml:"_xlfn.SKEW.P",odf:"SKEWP"},ceName:null,minParams:1,type:"val"},SLOPE:{category:"statistical",minParams:2,maxParams:2,type:"val"},SMALL:{category:"statistical",minParams:2,maxParams:2,type:"val"},STANDARDIZE:{category:"statistical",minParams:3,maxParams:3,type:"val"},STDEV:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:e("dev",!1,f)},"STDEV.P":{category:"statistical",name:{ooxml:"_xlfn.STDEV.P",odf:"COM.MICROSOFT.STDEV.P"},ceName:{odf:null},minParams:1,type:"val",signature:"any",resolve:"STDEVP"},"STDEV.S":{category:"statistical",name:{ooxml:"_xlfn.STDEV.S",odf:"COM.MICROSOFT.STDEV.S"},ceName:{odf:null},minParams:1,type:"val",signature:"any",resolve:"STDEV"},STDEVA:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:e("dev",!1,g)},STDEVP:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:e("dev",!0,f)},STDEVPA:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:e("dev",!0,g)},STEYX:{category:"statistical",minParams:2,maxParams:2,type:"val"},"T.DIST":{category:"statistical",name:{ooxml:"_xlfn.T.DIST",odf:"COM.MICROSOFT.T.DIST"},ceName:null,minParams:3,maxParams:3,type:"val"},"T.DIST.2T":{category:"statistical",name:{ooxml:"_xlfn.T.DIST.2T",odf:"COM.MICROSOFT.T.DIST.2T"},ceName:null,minParams:2,maxParams:2,type:"val"},"T.DIST.RT":{category:"statistical",name:{ooxml:"_xlfn.T.DIST.RT",odf:"COM.MICROSOFT.T.DIST.RT"},ceName:null,minParams:2,maxParams:2,type:"val"},"T.INV":{category:"statistical",name:{ooxml:"_xlfn.T.INV",odf:"COM.MICROSOFT.T.INV"},ceName:null,minParams:2,maxParams:2,type:"val"},"T.INV.2T":{category:"statistical",name:{ooxml:"_xlfn.T.INV.2T",odf:"COM.MICROSOFT.T.INV.2T"},ceName:null,minParams:2,maxParams:2,type:"val"},"T.TEST":{category:"statistical",name:{ooxml:"_xlfn.T.TEST",odf:"COM.MICROSOFT.T.TEST"},ceName:null,minParams:4,maxParams:4,type:"val"},TDIST:{category:"statistical",name:{odf:["LEGACY.TDIST","TDIST"]},minParams:3,maxParams:3,type:"val"},TINV:{category:"statistical",minParams:2,maxParams:2,type:"val"},TREND:{category:"statistical",minParams:1,maxParams:4,type:"mat"},TRIMMEAN:{category:"statistical",minParams:2,maxParams:2,type:"val"},TTEST:{category:"statistical",minParams:4,maxParams:4,type:"val"},VAR:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:e("var",!1,f)},"VAR.P":{category:"statistical",name:{ooxml:"_xlfn.VAR.P",odf:"COM.MICROSOFT.VAR.P"},ceName:{odf:null},minParams:1,type:"val",signature:"any",resolve:"VARP"},"VAR.S":{category:"statistical",name:{ooxml:"_xlfn.VAR.S",odf:"COM.MICROSOFT.VAR.S"},ceName:{odf:null},minParams:1,type:"val",signature:"any",resolve:"VAR"},VARA:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:e("var",!1,g)},VARP:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:e("var",!0,f)},VARPA:{category:"statistical",minParams:1,type:"val",signature:"any",resolve:e("var",!0,g)},WEIBULL:{category:"statistical",minParams:4,maxParams:4,type:"val"},"WEIBULL.DIST":{category:"statistical",name:{ooxml:"_xlfn.WEIBULL.DIST",odf:"COM.MICROSOFT.WEIBULL.DIST"},ceName:null,minParams:4,maxParams:4,type:"val"},"Z.TEST":{category:"statistical",name:{ooxml:"_xlfn.Z.TEST",odf:"COM.MICROSOFT.Z.TEST"},ceName:null,minParams:3,maxParams:3,type:"val"},ZTEST:{category:"statistical",minParams:2,maxParams:3,type:"val"}}});