define("io.ox/office/spreadsheet/model/formula/impl/textfuncs",["io.ox/office/tk/utils","io.ox/office/spreadsheet/utils/errorcode","io.ox/office/spreadsheet/model/formula/formulautils"],function(a,b,c){"use strict";return{ASC:{category:"text",hidden:!0,minParams:1,maxParams:1,type:"val"},BAHTTEXT:{category:"text",name:{odf:"COM.MICROSOFT.BAHTTEXT"},minParams:1,maxParams:1,type:"val"},CHAR:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val:int",resolve:function(a){if(1>a||a>255)throw b.VALUE;return String.fromCharCode(a)}},CLEAN:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:function(a){return a.replace(/[\x00-\x1f\x81\x8d\x8f\x90\x9d]/g,"")}},CODE:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:function(a){return 0===a.length?b.VALUE:a.charCodeAt(0)}},CONCATENATE:{category:"text",minParams:1,type:"val",signature:"val:str",resolve:function(){return _.reduce(arguments,c.add,"")}},DBCS:{category:"text",name:{odf:"JIS"},ceName:"JIS",hidden:!0,minParams:1,maxParams:1,type:"val"},DOLLAR:{category:"text",minParams:1,maxParams:2,type:"val"},EXACT:{category:"text",minParams:2,maxParams:2,type:"val",signature:"val:str val:str",resolve:function(a,b){return a===b}},FIND:{category:"text",minParams:2,maxParams:3,type:"val",signature:"val:str val:str val:int",resolve:function(a,c,d){if(_.isUndefined(d)&&(d=1),this.checkStringIndex(d),d-=1,d>c.length-a.length)throw b.VALUE;if(d=c.indexOf(a,d),0>d)throw b.VALUE;return d+1}},FINDB:{category:"text",ceName:null,hidden:!0,minParams:2,maxParams:3,type:"val",signature:"val:str val:str val:int",resolve:"FIND"},FIXED:{category:"text",minParams:1,maxParams:3,type:"val",signature:"val:num val:int val:bool",resolve:function(c,d,e){if(d>127)throw b.VALUE;_.isUndefined(d)&&(d=2),_.isUndefined(e)&&(e=!1);var f=e?"0":"#,##0",g=d>0?"."+a.repeatString("0",d):"";if(0>d){var h=Math.pow(10,d);if(h<Number.MIN_VALUE)return"0";c=Math.round(h*c)/h}return this.getNumberFormatter().formatValue(c,f+g)}},LEFT:{category:"text",minParams:1,maxParams:2,type:"val",signature:"val:str val:int",resolve:function(a,b){return _.isUndefined(b)&&(b=1),this.checkStringLength(b),0===b?a:a.substr(0,b)}},LEFTB:{category:"text",ceName:null,hidden:!0,minParams:1,maxParams:2,type:"val",signature:"val:str val:int",resolve:"LEFT"},LEN:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:_.property("length")},LENB:{category:"text",ceName:null,hidden:!0,minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:"LEN"},LOWER:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:function(a){return a.toLowerCase()}},MID:{category:"text",minParams:3,maxParams:3,type:"val",signature:"val:str val:int val:int",resolve:function(a,b,c){return this.checkStringIndex(b),this.checkStringLength(c),a.substr(b-1,c)}},MIDB:{category:"text",ceName:null,hidden:!0,minParams:3,maxParams:3,type:"val",signature:"val:str val:int val:int",resolve:"MID"},NUMBERVALUE:{category:"text",name:{ooxml:"_xlfn.NUMBERVALUE"},minParams:1,maxParams:3,type:"val"},PHONETIC:{category:"text",name:{odf:null},ceName:null,hidden:!0,minParams:1,maxParams:1,type:"val",signature:"ref:single"},PROPER:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:function(b){return b.replace(/[A-Za-z\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02B8\u02BB-\u02C1\u02D0-\u02D1\u02E0-\u02E4\u02EE\u0370-\u0373\u0376-\u0377\u037A-\u037D\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u0523]+/g,a.capitalize)}},REPLACE:{category:"text",minParams:4,maxParams:4,type:"val",signature:"val:str val:int val:int val:str",resolve:function(b,c,d,e){return this.checkStringIndex(c),this.checkStringLength(d),c-=1,a.replaceSubString(b,c,c+d,e)}},REPLACEB:{category:"text",ceName:null,hidden:!0,minParams:4,maxParams:4,type:"val",signature:"val:str val:int val:int val:str",resolve:"REPLACE"},REPT:{category:"text",minParams:2,maxParams:2,type:"val",signature:"val:str val:int",resolve:function(b,c){return this.checkStringLength(b.length*c),0===b.length?"":a.repeatString(b,c)}},RIGHT:{category:"text",minParams:1,maxParams:2,type:"val",signature:"val:str val:int",resolve:function(a,b){return _.isUndefined(b)&&(b=1),this.checkStringLength(b),0===b?a:a.substr(-b)}},RIGHTB:{category:"text",ceName:null,hidden:!0,minParams:1,maxParams:2,type:"val",signature:"val:str val:int",resolve:"RIGHT"},ROT13:{category:"text",name:{ooxml:null,odf:"ORG.OPENOFFICE.ROT13"},ceName:{ooxml:null},minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:function(a){return a.replace(/[a-zA-Z]/g,function(a){return String.fromCharCode(((a=a.charCodeAt())<91?78:110)>a?a+13:a-13)})}},SEARCH:{category:"text",minParams:2,maxParams:3,type:"val",signature:"val:str val:str val:int",resolve:function(a,c,d){if(_.isUndefined(d)&&(d=1),this.checkStringIndex(d),d-=1,/^\**$/.test(a)){if(c.length<=d)throw b.VALUE;return d+1}c=c.substr(d);var e=this.convertPatternToRegExp(a),f=e.exec(c);if(!_.isArray(f))throw b.VALUE;return f.index+d+1}},SEARCHB:{category:"text",ceName:null,hidden:!0,minParams:2,maxParams:3,type:"val",signature:"val:str val:str val:int",resolve:"SEARCH"},SUBSTITUTE:{category:"text",minParams:3,maxParams:4,type:"val",signature:"val:str val:str val:str val:int",resolve:function(a,c,d,e){if(_.isNumber(e)&&0>=e)throw b.VALUE;if(0===c.length)return a;var f=new RegExp(_.escapeRegExp(c),"g");if(_.isUndefined(e))return a.replace(f,d);var g=a.split(f);return e<g.length?(g[e-1]+=d+g[e],g.splice(e,1),g.join(c)):a}},T:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val",resolve:function(a){return _.isString(a)?a:""}},TEXT:{category:"text",minParams:2,maxParams:2,type:"val"},TRIM:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:function(a){return a.replace(/^ +| +$/,"").replace(/ {2,}/g," ")}},UNICHAR:{category:"text",name:{ooxml:"_xlfn.UNICHAR"},minParams:1,maxParams:1,type:"val",signature:"val:int",resolve:function(a){if(1>a||a>65535)throw b.VALUE;var c=String.fromCharCode(a);if(/[\ud800-\udfff\ufdd0-\ufdef\ufffe\uffff]/.test(c))throw b.NA;return c}},UNICODE:{category:"text",name:{ooxml:"_xlfn.UNICODE"},minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:function(a){return 0===a.length?b.VALUE:a.charCodeAt(0)}},UPPER:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:function(a){return a.toUpperCase()}},USDOLLAR:{category:"text",name:{odf:null},ceName:null,hidden:!0,minParams:1,maxParams:2,type:"val"},VALUE:{category:"text",minParams:1,maxParams:1,type:"val",signature:"val:str",resolve:function(a){return this.convertToNumber(a)}}}});