define("io.ox/office/spreadsheet/model/formula/interpreter",["io.ox/office/tk/utils","io.ox/office/tk/object/baseobject","io.ox/office/baseframework/model/modelobject","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/complex","io.ox/office/spreadsheet/model/formula/matrix","io.ox/office/spreadsheet/model/formula/operand","io.ox/office/spreadsheet/model/formula/formulacontext"],function(a,b,c,d,e,f,g,h,i){"use strict";function j(a){return a.forEach(e.throwErrorCode),a}function k(a,b){return a.forEach(function(a){if(e.throwErrorCode(a),!b(a))throw n.VALUE}),a}function l(a){if(a.empty())throw n.NULL;if(!a.singleSheet())throw n.VALUE;return a}function m(a){c.call(this,a),this.interpretTokens=function(b,c,d){var f=new s(a,c,d),g=null;try{switch(e.takeTime("Interpreter.interpretTokens(): contextType="+b,function(){g=f.getResult(b)}),b="any"===b?g.getType():b){case"val":g=g.getValue(),_.isNull(g)&&(g=0);break;case"mat":g=g.getMatrix();break;case"ref":g=g.getRanges();break;default:e.throwInternal('FormulaInterpreter.interpretTokens(): unknown context type: "'+b+'"')}e.throwErrorCode(g),g={type:"result",value:g}}catch(h){if(h instanceof n)g=h.internal?{type:"warn",value:h.key}:{type:"result",value:h};else{if(!_.isString(h))throw h;e.warn("  error: "+h),g={type:"error",value:h}}}finally{f.destroy()}return e.info("result: type="+g.type+", value="+e.valueToString(g.value)),g},this.registerDestructor(function(){a=null})}var n=d.ErrorCode,o=d.Address,p=d.Range3D,q=d.Range3DArray,r=1e3,s=b.extend({constructor:function(c,d,m){function s(a){var b=a.getRange3D(m);return b?new q(b):n.REF}function t(a,b){var c=b.resolveNameModel(F);if(!c)return n.NAME;var d=c.getTokenArray().interpretFormula(a,{refSheet:F,refAddress:o.A1,targetAddress:G});return"result"===d.type?d.value:e.UNSUPPORTED_ERROR}function u(a,b){if("ref"===b&&"ref"!==a&&"any"!==a)throw"reference"}function v(a){return _.isNumber(a)||_.isString(a)||_.isBoolean(a)||a instanceof Date||a instanceof f||a instanceof n}function w(a){return a instanceof g}function x(a){return a instanceof p||a instanceof q}function y(a,b){switch(b){case"val":return v(a);case"mat":return w(a);case"ref":return x(a);case"any":return v(a)||w(a)||x(a)||a instanceof h}e.throwInternal('isValueOfType(): unknown type identifier: "'+b+'"')}function z(a,b){var c=a.token,d=null,f=null;switch(e.log("> resolving operand token: "+c),c.getType()){case"lit":f=c.getValue(),d=f===n.REF?"ref":"val";break;case"mat":f=c.getMatrix(),d="mat";break;case"ref":f=s(c),d="ref";break;case"name":f=t(b,c),d="any";break;default:e.throwInternal('InterpreterInstance.makeTokenOperand(): unknown token type: "'+c.getType()+'"')}return u(d,b),new h(H,f)}function A(a,b,c,d){switch(b){case"any":return a;case"val":return e.throwErrorCode(a.getValue(c,d));case"val:num":return H.convertToNumber(a.getValue(c,d));case"val:int":return H.convertToNumber(a.getValue(c,d),!0);case"val:date":return H.convertToDate(a.getValue(c,d));case"val:day":return H.convertToDate(a.getValue(c,d),!0);case"val:str":return H.convertToString(a.getValue(c,d));case"val:bool":return H.convertToBoolean(a.getValue(c,d));case"val:comp":return H.convertToComplex(a.getValue(c,d));case"val:any":return a.getValue(c,d);case"mat":return j(a.getMatrix());case"mat:num":return k(a.getMatrix(),_.isNumber);case"mat:str":return k(a.getMatrix(),_.isString);case"mat:bool":return k(a.getMatrix(),_.isBoolean);case"mat:any":return a.getMatrix();case"ref":return a.getRanges();case"ref:sheet":return l(a.getRanges());case"ref:single":return H.convertToRange(a.getRanges());case"ref:multi":return H.convertToRange(a.getRanges(),{multiSheet:!0})}e.throwInternal('InterpreterInstance.resolveParam(): unknown parameter signature type: "'+b+'"')}function B(b,c){function d(a){if(j.signature.length<=a){var b=_.isNumber(j.repeatCount)?j.repeatCount:1;a=j.signature.length-b+(a-j.signature.length)%b}return j.signature[a]}function f(a,b){var c=null,d=null;try{c=l.map(function(c,d){return A(c,k[d].paramType,a,b)}),e.logTokens("  resolving with parameters",c),d=j.resolve.apply(H,c),y(d,j.type)||e.throwInternal("InterpreterInstance.resolveOperator(): "+j.name+": operator result type does not match operator return type")}catch(f){if(!(f instanceof n))throw f;d=f}return!e.isLoggingActive()&&_.now()-J>r&&(d=e.UNSUPPORTED_ERROR),d}var i=b.token,j=null,k=null,l=null,m=0,o=0,p=null;if(e.log("> processing operator "+i+" with "+b.params+" parameters"),j=i.isType("op")?D.get(i.getValue()):i.isType("func")?E.get(i.getValue()):null,!j)return new h(H,n.NAME);u(j.type,c);var q=j.minParams,s=0,t=0;if("maxParams"in j?(s=j.maxParams,t=1):(t=_.isNumber(j.repeatParams)?j.repeatParams:1,s=q+a.roundDown(e.MAX_PARAM_COUNT-q,t)),b.params<q)throw"missing";if(b.params>s)throw"unexpected";if((b.params-q)%t!==0)throw"missing";if(!_.isFunction(j.resolve))return e.warn('InterpreterInstance.processOperator(): unsupported operator or function "'+i+'"'),new h(H,e.UNSUPPORTED_ERROR);if(k=_.times(b.params,function(a){var b=d(a),c=b.split(":")[0];return{paramType:b,baseType:c}}),l=k.map(function(a){var b=a.baseType;return"mat"===c&&"val"===a.baseType&&"val"===j.type&&(b="mat"),C(b)}),"val"===j.type&&l.forEach(function(a,b){if("val"===k[b].baseType&&("mat"===c&&a.isReference()&&(a=l[b]=new h(H,a.getMatrix())),a.isMatrix())){var d=a.getMatrix();m=Math.max(m,d.rows()),o=Math.max(o,d.cols())}}),H.registerOperands(l),m*o>0){if(!e.isValidMatrixSize(m,o))return new h(H,e.UNSUPPORTED_ERROR);e.info("  process as "+m+"x"+o+" matrix"),p=g.generate(m,o,f)}else p=f();return p instanceof h?p:new h(H,p)}function C(a){var b=d[I],c=null;switch(b||e.throwInternal("InterpreterInstance.getNextOperand(): missing compiler token"),I+=1,b.type){case"val":c=z(b,a);break;case"op":c=B(b,a);break;default:e.throwInternal('InterpreterInstance.getNextOperand(): unknown token type: "'+b.type+'"')}return e.log("< result of "+b+": "+c),c}var D=c.getFormulaResource().getOperatorCollection(),E=c.getFormulaResource().getFunctionCollection(),F=a.getIntegerOption(m,"refSheet",null),G=a.getOption(m,"targetAddress",o.A1),H=new i(c,F,G),I=0,J=0;b.call(this),this.getResult=function(a){return J=_.now(),C(a)},this.registerDestructor(function(){c=d=m=H=null})}});return c.extend({constructor:m})});