define("io.ox/office/spreadsheet/model/formula/tokenizer",["io.ox/office/tk/utils","io.ox/office/tk/locale/parser","io.ox/office/baseframework/model/modelobject","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/grammarconfig","io.ox/office/spreadsheet/model/formula/sheetref","io.ox/office/spreadsheet/model/formula/cellref","io.ox/office/spreadsheet/model/formula/tokens"],function(a,b,c,d,e,f,g,h,i){"use strict";function j(a,b){this.token=a,this.index=-1,this.text=b,this.start=0,this.end=0}function k(b){c.call(this,b),this.parseFormula=function(c,d,f){e.info('Tokenizer.parseFormula(): grammar="'+c+'", formula="'+d+'"');var g=b.getGrammarConfig(c),h=function(){switch(g.REF_SYNTAX){case"ooxml":return new n(b,g,f);case"odfui":return new o(b,g,f);case"of":return new p(b,g,f)}}(),j=h.parseFormula(d),k=" "===g.getOperatorName("isect");return e.logTokens("  tokenize",j),a.iterateArray(j,function(a,b){var c=a.token,d=j[b-1],e=j[b+1],f=d&&d.token.isType("ws")?j[b-2]:d,g=null;c.isType("op")&&"sub"===c.getValue()&&e&&e.token.isType("lit")&&_.isNumber(g=e.token.getValue())&&g>0&&(!f||f.token.matchesType(/^(op|sep|open)$/))&&(a.token=new i.LiteralToken(-g),a.text+=e.text,j.splice(b+1,1));var l=null;if(k&&c.isType("ws")&&(l=a.text.indexOf(" "))>=0&&d&&d.token.matchesType(/^(ref|name|close)$/)&&e&&e.token.matchesType(/^(ref|name|open|func)$/)){if(l+1<a.text.length){var m=a.text.slice(l+1);j.splice(b+1,0,h.createFixedToken("ws",m))}j.splice(b+1,0,h.createToken(new i.OperatorToken("isect")," ")),l>0?(c.setValue(a.text.slice(0,l)),a.text=c.getValue()):j.splice(b,1)}},{reverse:!0,context:this}),e.logTokens("  postprocess",j),j.forEach(function(a,b){a.index=b,a.start=0===b?0:j[b-1].end,a.end=a.start+a.text.length}),j},this.registerDestructor(function(){b=null})}var l=d.Address;j.prototype.toString=function(){return this.token.toString()};var m=_.makeExtendable(function(b,c,d){this.docModel=b,this.MAXCOL=b.getMaxCol(),this.MAXROW=b.getMaxRow(),this.config=c,this.RE=c.RE,this.extendSheet=a.getIntegerOption(d,"extendSheet",-1),this.extendSheetModel=b.getSheetModel(this.extendSheet),this.matrix=!1});m.prototype._parseNextGlobalToken=function(a){var c=null,d=null;return(c=this.RE.STRING_LIT.exec(a))?this.createLiteralToken(c[0].slice(1,c[0].length-1).replace(/""/g,'"'),c[0]):(c=this.RE.BOOLEAN_LIT.exec(a))?this.createLiteralToken(this.config.getBooleanValue(c[0]),c[0]):(c=this.RE.ERROR_LIT.exec(a))?this.createLiteralToken(this.config.getErrorCode(c[0]),c[0]):(c=this.RE.WHITESPACE.exec(a))?this.createFixedToken("ws",c[0]):(c=this.RE.SEPARATOR.exec(a))?this.createToken(new i.SeparatorToken,c[0]):(c=this.RE.OPERATOR.exec(a))?this.createToken(new i.OperatorToken(this.config.getOperatorKey(c[0])),c[0]):(c=this.RE.OPEN.exec(a))?this.createToken(new i.ParenthesisToken(!0),c[0]):(c=this.RE.CLOSE.exec(a))?this.createToken(new i.ParenthesisToken(!1),c[0]):(c=this.RE.MATRIX_OPEN.exec(a))?(this.matrix=!0,this.createToken(new i.MatrixDelimiterToken("mat_open"),c[0])):(d=this._parseNextRefToken(a))?d:(c=b.parseLeadingNumber(a,{dec:this.config.DEC}))?this.createLiteralToken(c.number,c.text):(d=this._parseNextNameToken(a))?d:void 0},m.prototype._parseNextMatrixToken=function(a){var c=null;return(c=b.parseLeadingNumber(a,{dec:this.config.DEC,sign:!0}))?this.createLiteralToken(c.number,c.text):(c=this.RE.STRING_LIT.exec(a))?this.createLiteralToken(c[0].slice(1,c[0].length-1).replace(/""/g,'"'),c[0]):(c=this.RE.BOOLEAN_LIT.exec(a))?this.createLiteralToken(this.config.getBooleanValue(c[0]),c[0]):(c=this.RE.ERROR_LIT.exec(a))?this.createLiteralToken(this.config.getErrorCode(c[0]),c[0]):(c=this.RE.WHITESPACE.exec(a))?this.createFixedToken("ws",c[0]):(c=this.RE.MATRIX_ROW_SEPARATOR.exec(a))?this.createToken(new i.MatrixDelimiterToken("mat_row"),c[0]):(c=this.RE.MATRIX_COL_SEPARATOR.exec(a))?this.createToken(new i.MatrixDelimiterToken("mat_col"),c[0]):(c=this.RE.MATRIX_CLOSE.exec(a))?(this.matrix=!1,this.createToken(new i.MatrixDelimiterToken("mat_close"),c[0])):void 0},m.prototype._createSheetRef=function(a,b,c){return c||(c=!!a[b],b+=1),g.create(this.docModel,a[b],a[b+1],a[b+2],c)},m.prototype._createSheetRefData=function(a,b,c){return{r1:this._createSheetRef(a,b,c),r2:null}},m.prototype._createA1CellRef=function(a,b){var c=l.parseCol(a[b+1]),d=l.parseRow(a[b+3]);return c>=0&&c<=this.MAXCOL&&d>=0&&d<=this.MAXROW?new h(c,d,!!a[b],!!a[b+2]):null},m.prototype._createA1ColRef=function(a,b,c){var d=l.parseCol(a[b+1]);return d>=0&&d<=this.MAXCOL?new h(d,c,!!a[b],!0):null},m.prototype._createA1RowRef=function(a,b,c){var d=l.parseRow(a[b+1]);return d>=0&&d<=this.MAXROW?new h(c,d,!0,!!a[b]):null},m.prototype._createA1CellData=function(a,b){var c=this._createA1CellRef(a,b);return c?{r1:c,r2:null}:null},m.prototype._createA1CellRangeData=function(a,b,c){var d=this._createA1CellRef(a,b),e=d?this._createA1CellRef(a,c):null;return e?{r1:d,r2:e}:null},m.prototype._createA1ColRangeData=function(a,b,c){var d=this._createA1ColRef(a,b,0),e=d?this._createA1ColRef(a,c,this.MAXROW):null;return e?{r1:d,r2:e}:null},m.prototype._createA1RowRangeData=function(a,b,c){var d=this._createA1RowRef(a,b,0),e=d?this._createA1RowRef(a,c,this.MAXCOL):null;return e?{r1:d,r2:e}:null},m.prototype._parseNextRefToken=function(){return a.error("ExpressionParser._parseNextRefToken(): missing implementation"),null},m.prototype._parseNextNameToken=function(){return a.error("ExpressionParser._parseNextNameToken(): missing implementation"),null},m.prototype.createToken=function(a,b){return new j(a,b)},m.prototype.createFixedToken=function(a,b){return this.createToken(new i.FixedToken(a,b),b)},m.prototype.createLiteralToken=function(a,b){return this.createToken(new i.LiteralToken(a),b)},m.prototype.createReferenceToken=function(a,b,c){return!a&&this.extendSheetModel&&(a={r1:new g(this.extendSheet,!0),r2:null}),this.createToken(new i.ReferenceToken(this.docModel,b?b.r1:null,b?b.r2:null,a?a.r1:null,a?a.r2:null),c)},m.prototype.createNameToken=function(a,b,c){return!a&&this.extendSheetModel&&this.extendSheetModel.getNameCollection().hasNameModel(b)&&(a=new g(this.extendSheet,!0)),this.createToken(new i.NameToken(this.docModel,b,a),c)},m.prototype.createFunctionToken=function(a,b,c){var d=a?null:this.config.getFunctionKey(b);return this.createToken(d?new i.FunctionToken(d):new i.MacroToken(this.docModel,b,a),c)},m.prototype.parseFormula=function(a){for(var b=[];a.length>0;){var c=this.matrix?this._parseNextMatrixToken(a):this._parseNextGlobalToken(a);c||(c=this.createFixedToken("bad",a)),b.push(c),a=a.substr(c.text.length)}return b};var n=m.extend({constructor:function(a,b,c){m.call(this,a,b,c)}});n.prototype._createSheetRangeData=function(a,b){var c=g.create(this.docModel,a[b],a[b+2],null,!0),d=g.create(this.docModel,a[b+1],a[b+3],null,!0);return{r1:c,r2:d}},n.prototype._parseNextRefToken=function(a){var b=null,c=null;return(b=this.RE.CELL_RANGE_REF.exec(a))&&(c=this._createA1CellRangeData(b,1,5))?this.createReferenceToken(null,c,b[0]):(b=this.RE.CELL_RANGE_ABS3D_REF.exec(a))&&(c=this._createA1CellRangeData(b,4,8))?this.createReferenceToken(this._createSheetRefData(b,1,!0),c,b[0]):(b=this.RE.CELL_RANGE_ABSCUBE_REF.exec(a))&&(c=this._createA1CellRangeData(b,5,9))?this.createReferenceToken(this._createSheetRangeData(b,1),c,b[0]):(b=this.RE.CELL_REF.exec(a))&&(c=this._createA1CellData(b,1))?this.createReferenceToken(null,c,b[0]):(b=this.RE.CELL_ABS3D_REF.exec(a))&&(c=this._createA1CellData(b,4))?this.createReferenceToken(this._createSheetRefData(b,1,!0),c,b[0]):(b=this.RE.CELL_ABSCUBE_REF.exec(a))&&(c=this._createA1CellData(b,5))?this.createReferenceToken(this._createSheetRangeData(b,1),c,b[0]):(b=this.RE.COL_RANGE_REF.exec(a))&&(c=this._createA1ColRangeData(b,1,3))?this.createReferenceToken(null,c,b[0]):(b=this.RE.COL_RANGE_ABS3D_REF.exec(a))&&(c=this._createA1ColRangeData(b,4,6))?this.createReferenceToken(this._createSheetRefData(b,1,!0),c,b[0]):(b=this.RE.COL_RANGE_ABSCUBE_REF.exec(a))&&(c=this._createA1ColRangeData(b,5,7))?this.createReferenceToken(this._createSheetRangeData(b,1),c,b[0]):(b=this.RE.ROW_RANGE_REF.exec(a))&&(c=this._createA1RowRangeData(b,1,3))?this.createReferenceToken(null,c,b[0]):(b=this.RE.ROW_RANGE_ABS3D_REF.exec(a))&&(c=this._createA1RowRangeData(b,4,6))?this.createReferenceToken(this._createSheetRefData(b,1,!0),c,b[0]):(b=this.RE.ROW_RANGE_ABSCUBE_REF.exec(a))&&(c=this._createA1RowRangeData(b,5,7))?this.createReferenceToken(this._createSheetRangeData(b,1),c,b[0]):(b=this.RE.ERROR_ABS3D_REF.exec(a))?this.createReferenceToken(this._createSheetRefData(b,1,!0),null,b[0]):(b=this.RE.ERROR_ABSCUBE_REF.exec(a))?this.createReferenceToken(this._createSheetRangeData(b,1),null,b[0]):void 0},n.prototype._parseNextNameToken=function(a){var b=null;return(b=this.RE.FUNCTION_REF.exec(a))?this.createFunctionToken(null,b[1],b[0]):(b=this.RE.FUNCTION_ABS3D_REF.exec(a))?this.createFunctionToken(this._createSheetRef(b,1,!0),b[4],b[0]):(b=this.RE.NAME_ABS3D_REF.exec(a))?this.createNameToken(this._createSheetRef(b,1,!0),b[4],b[0]):(b=this.RE.NAME_REF.exec(a))?this.createNameToken(null,b[1],b[0]):void 0};var o=m.extend({constructor:function(a,b,c){m.call(this,a,b,c)}});o.prototype._createSheetRangeData=function(a,b){var c=g.create(this.docModel,a[b+1],a[b+2],null,!!a[b]),d=g.create(this.docModel,a[b+4],a[b+5],null,!!a[b+3]);return{r1:c,r2:d}},o.prototype._parseNextRefToken=function(a){var b=null,c=null;return(b=this.RE.CELL_RANGE_REF.exec(a))&&(c=this._createA1CellRangeData(b,1,5))?this.createReferenceToken(null,c,b[0]):(b=this.RE.CELL_RANGE_REL3D_REF.exec(a))&&(c=this._createA1CellRangeData(b,5,9))?this.createReferenceToken(this._createSheetRefData(b,1),c,b[0]):(b=this.RE.CELL_RANGE_RELCUBE_REF.exec(a))&&(c=this._createA1CellRangeData(b,7,11))?this.createReferenceToken(this._createSheetRangeData(b,1),c,b[0]):(b=this.RE.CELL_REF.exec(a))&&(c=this._createA1CellData(b,1))?this.createReferenceToken(null,c,b[0]):(b=this.RE.CELL_REL3D_REF.exec(a))&&(c=this._createA1CellData(b,5))?this.createReferenceToken(this._createSheetRefData(b,1),c,b[0]):(b=this.RE.CELL_RELCUBE_REF.exec(a))&&(c=this._createA1CellData(b,7))?this.createReferenceToken(this._createSheetRangeData(b,1),c,b[0]):(b=this.RE.COL_RANGE_REF.exec(a))&&(c=this._createA1ColRangeData(b,1,3))?this.createReferenceToken(null,c,b[0]):(b=this.RE.COL_RANGE_REL3D_REF.exec(a))&&(c=this._createA1ColRangeData(b,5,7))?this.createReferenceToken(this._createSheetRefData(b,1),c,b[0]):(b=this.RE.COL_RANGE_RELCUBE_REF.exec(a))&&(c=this._createA1ColRangeData(b,7,9))?this.createReferenceToken(this._createSheetRangeData(b,1),c,b[0]):(b=this.RE.ROW_RANGE_REF.exec(a))&&(c=this._createA1RowRangeData(b,1,3))?this.createReferenceToken(null,c,b[0]):(b=this.RE.ROW_RANGE_REL3D_REF.exec(a))&&(c=this._createA1RowRangeData(b,5,7))?this.createReferenceToken(this._createSheetRefData(b,1),c,b[0]):(b=this.RE.ROW_RANGE_RELCUBE_REF.exec(a))&&(c=this._createA1RowRangeData(b,7,9))?this.createReferenceToken(this._createSheetRangeData(b,1),c,b[0]):(b=this.RE.ERROR_REL3D_REF.exec(a))?this.createReferenceToken(this._createSheetRefData(b,1),null,b[0]):(b=this.RE.ERROR_RELCUBE_REF.exec(a))?this.createReferenceToken(this._createSheetRangeData(b,1),null,b[0]):void 0},o.prototype._parseNextNameToken=function(a){var b=null;return(b=this.RE.FUNCTION_REF.exec(a))?this.createFunctionToken(null,b[1],b[0]):(b=this.RE.NAME_REF.exec(a))?this.createNameToken(null,b[1],b[0]):void 0};var p=m.extend({constructor:function(a,b,c){m.call(this,a,b,c)}});return p.prototype._createSheetRangeData=function(a,b,c){return{r1:this._createSheetRef(a,b),r2:this._createSheetRef(a,c)}},p.prototype._parseNextRefToken=function(a){var b=null;return(b=this.RE.OF_CELL_REF.exec(a))?this.createReferenceToken(null,this._createA1CellData(b,1),b[0]):(b=this.RE.OF_CELL_3D_REF.exec(a))?this.createReferenceToken(this._createSheetRefData(b,1),this._createA1CellData(b,5),b[0]):(b=this.RE.OF_CELL_RANGE_REF.exec(a))?this.createReferenceToken(null,this._createA1CellRangeData(b,1,5),b[0]):(b=this.RE.OF_CELL_RANGE_3D_REF.exec(a))?this.createReferenceToken(this._createSheetRefData(b,1),this._createA1CellRangeData(b,5,9),b[0]):(b=this.RE.OF_CELL_RANGE_CUBE_REF.exec(a))?this.createReferenceToken(this._createSheetRangeData(b,1,9),this._createA1CellRangeData(b,5,13),b[0]):void 0},p.prototype._parseNextNameToken=function(a){var b=null;return(b=this.RE.OF_FUNCTION_REF.exec(a))?this.createFunctionToken(null,b[1],b[0]):(b=this.RE.NAME_REF.exec(a))?this.createNameToken(null,b[1],b[0]):void 0},c.extend({constructor:k})});