define("io.ox/office/spreadsheet/model/formula/tokens",["io.ox/office/tk/utils","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/cellref"],function(a,b,c,d){"use strict";function e(a){return _.isObject(a)&&!a.valid()}function f(a,b){return _.isObject(a)&&_.isNumber(a.sheet)&&(!a.abs||a.sheet===b)}var g=b.Address,h=b.Range,i=b.Range3D,j=_.makeExtendable(function(a){this._type=a});j.prototype.getType=function(){return this._type},j.prototype.isType=function(a){return a===this._type},j.prototype.matchesType=function(a){return a.test(this._type)},j.prototype.getText=function(){return a.error("BaseToken.getText(): missing implementation"),""},j.prototype.debugText=function(){return a.error("BaseToken.debugText(): missing implementation"),""},j.prototype.toString=function(){var a=this.debugText();return this._type+(a?"["+a+"]":"")};var k=j.extend({constructor:function(a,b){j.call(this,a),this._text=b}});k.prototype.getValue=function(){return this._text},k.prototype.setValue=function(a){return this._text===a?!1:(this._text=a,!0)},k.prototype.appendValue=function(a){return 0===a.length?!1:(this._text+=a,!0)},k.prototype.getText=function(){return this._text},k.prototype.debugText=function(){return this._text};var l=j.extend({constructor:function(a){j.call(this,"op"),this._value=a}});l.prototype.getValue=function(){return this._value},l.prototype.getText=function(a){return a.getOperatorName(this._value)||"?"},l.prototype.debugText=function(){return this._value};var m=j.extend({constructor:function(){j.call(this,"sep")}});m.prototype.getText=function(a){return a.SEP},m.prototype.debugText=_.constant("");var n=k.extend({constructor:function(a){k.call(this,a?"open":"close",a?"(":")")}});n.prototype.debugText=_.constant("");var o=k.extend({constructor:function(a){j.call(this,a)}});o.prototype.getText=function(b){switch(this.getType()){case"mat_open":return b.MAT_OPEN;case"mat_close":return b.MAT_CLOSE;case"mat_row":return b.MAT_ROW;case"mat_col":return b.MAT_COL}return a.error("MatrixDelimiterToken.getText(): invalid matrix delimiter type"),""},o.prototype.debugText=_.constant("");var p=j.extend({constructor:function(a){j.call(this,"lit"),this._value=a}});p.prototype.getValue=function(){return this._value},p.prototype.setValue=function(a){return this._value===a?!1:(this._value=a,!0)},p.prototype.getText=function(a){return a.formatScalar(this._value)},p.prototype.debugText=function(){return c.valueToString(this._value)};var q=j.extend({constructor:function(a){j.call(this,"mat"),this._matrix=a}});q.prototype.getMatrix=function(){return this._matrix},q.prototype.getText=function(a){return a.MAT_OPEN+this._matrix.array.map(function(b){return b.map(function(b){return a.formatScalar(b)}).join(a.MAT_COL)}).join(a.MAT_ROW)+a.MAT_CLOSE},q.prototype.debugText=function(){return this._matrix.toString()};var r=j.extend({constructor:function(a){j.call(this,"func"),this._value=a}});r.prototype.getValue=function(){return this._value},r.prototype.getText=function(a){return a.getFunctionName(this._value)||this._value.toUpperCase()},r.prototype.debugText=function(){return this._value};var s=j.extend({constructor:function(a,b,c,d){j.call(this,a),this._docModel=b,this._sheet1Ref=c,this._sheet2Ref=d}});s.prototype._resolveSheetRange=function(b){var c=this._sheet1Ref?this._sheet1Ref.sheet:a.getIntegerOption(b,"refSheet",null),d=this._sheet2Ref?this._sheet2Ref.sheet:c;return _.isNumber(c)&&c>=0&&_.isNumber(d)&&d>=0?{sheet1:Math.min(c,d),sheet2:Math.max(c,d)}:null},s.prototype.hasSheetRef=function(){return _.isObject(this._sheet1Ref)},s.prototype.hasSheetError=function(){return e(this._sheet1Ref)||e(this._sheet2Ref)},s.prototype.transformSheet=function(a,b){var c=_.isObject(this._sheet1Ref)&&this._sheet1Ref.transform(a,b),d=_.isObject(this._sheet2Ref)&&this._sheet2Ref.transform(a,b);return c||d},s.prototype.relocateSheet=function(a,b){var c=_.isObject(this._sheet1Ref)&&this._sheet1Ref.relocate(a,b),d=_.isObject(this._sheet2Ref)&&this._sheet2Ref.relocate(a,b);return c||d},s.prototype.renameSheet=function(a){return f(this._sheet1Ref,a)||f(this._sheet2Ref,a)},s.prototype.debugSheetPrefix=function(){if(!this._sheet1Ref)return"";var a=this._sheet1Ref.toString();return this._sheet2Ref&&!this._sheet1Ref.equals(this._sheet2Ref)&&(a+=":"+this._sheet2Ref.toString()),a+"!"};var t=s.extend({constructor:function(a,b,c,d,e){s.call(this,"ref",a,d,e),this._cell1Ref=b,this._cell2Ref=c}});t.prototype._resolveCellRefs=function(b){var c=a.getOption(b,"refAddress",g.A1),d=a.getOption(b,"targetAddress",g.A1);if(c.equals(d))return{r1:this._cell1Ref,r2:this._cell2Ref};var e={r1:this._cell1Ref?this._cell1Ref.clone():null,r2:this._cell2Ref?this._cell2Ref.clone():null},f=a.getBooleanOption(b,"wrapReferences",!1);return e.r1&&!e.r1.relocate(this._docModel,c,d,f)&&(e.r1=null),e.r1&&e.r2&&!e.r2.relocate(this._docModel,c,d,f)&&(e.r1=e.r2=null),e},t.prototype.getRange3D=function(a){var b=this._resolveSheetRange(a);if(!b)return null;var c=this._resolveCellRefs(a);if(!c.r1)return null;var d=h.createFromAddresses(c.r1.toAddress(),c.r2&&c.r2.toAddress());return i.createFromRange(d,b.sheet1,b.sheet2)},t.prototype.setRange=function(a){var b=!1;return this._cell1Ref&&this._cell1Ref.toAddress().differs(a.start)?(this._cell1Ref.col=a.start[0],this._cell1Ref.row=a.start[1],b=!0):this._cell1Ref||(this._cell1Ref=d.create(a.start,!0,!0),this._cell2Ref=null,b=!0),this._cell2Ref||a.single()||(this._cell2Ref=this._cell1Ref.clone(),b=!0),this._cell2Ref&&this._cell2Ref.toAddress().differs(a.end)&&(this._cell2Ref.col=a.end[0],this._cell2Ref.row=a.end[1],this._cell1Ref.equals(this._cell2Ref)&&(this._cell2Ref=null),b=!0),b},t.prototype.transformRange=function(a,b,c,d,e){var f=this.getRange3D({refSheet:e});if(!f||!f.isSheet(a))return!1;var g=this._docModel.transformRange(f,b,c,d);return g&&g.equals(f)?!1:(g?this.setRange(g):this._cell1Ref=this._cell2Ref=null,!0)},t.prototype.relocateRange=function(a,b,c){return!this._cell1Ref||a.equals(b)?!1:this._cell1Ref.relocate(this._docModel,a,b,c)?(this._cell2Ref&&!this._cell2Ref.relocate(this._docModel,a,b,c)&&(this._cell1Ref=this._cell2Ref=null),!0):(this._cell1Ref=this._cell2Ref=null,!0)},t.prototype.getText=function(a,b){var c=this._resolveCellRefs(b);return a.formatReference(this._docModel,this._sheet1Ref,this._sheet2Ref,c.r1,c.r2)},t.prototype.debugText=function(){var a=this.debugSheetPrefix();return a+=this._cell1Ref?this._cell1Ref.toString():"#REF",a+=this._cell1Ref&&this._cell2Ref?":"+this._cell2Ref.toString():""};var u=s.extend({constructor:function(a,b,c){s.call(this,"name",a,c,null),this._value=b}});u.prototype._getNameModelFromSheet=function(a){var b=_.isNumber(a)?this._docModel.getSheetModel(a):null;return b?b.getNameCollection().getNameModel(this._value):null},u.prototype.getValue=function(){return this._value},u.prototype.resolveNameModel=function(a){return this._sheet1Ref?this._getNameModelFromSheet(this._sheet1Ref.sheet):this._getNameModelFromSheet(a)||this._docModel.getNameCollection().getNameModel(this._value)},u.prototype.getText=function(a){return a.formatName(this._docModel,this._sheet1Ref,this._value)},u.prototype.debugText=function(){return this.debugSheetPrefix()+this._value};var v=s.extend({constructor:function(a,b,c){s.call(this,"macro",a,c,null),this._value=b}});v.prototype.getValue=function(){return this._value},v.prototype.getText=function(a){return a.formatName(this._docModel,this._sheet1Ref,this._value)},v.prototype.debugText=function(){return this.debugSheetPrefix()+this._value};var w={FixedToken:k,OperatorToken:l,SeparatorToken:m,ParenthesisToken:n,MatrixDelimiterToken:o,LiteralToken:p,MatrixToken:q,FunctionToken:r,ReferenceToken:t,NameToken:u,MacroToken:v};return w});